<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CModule_sshow_crud extends CModule {

	private $table_name = "sshow";

	protected function setup() {
		parent::setup();
		CState::setup();
		CEnv::useLib( "sshow" );
		CEnv::useLib( "app" );
		CEnv::useLib( "tmp" );

		$this->sc = null;
		$this->dt = null;
		$this->fs = null;
	}

	private function loadFS() {
		if ( !isset( $this->fs ) ) {
			$this->fs = CDatabase::table(
				$this->table_name )->fieldset();
		}
		return $this->fs;
	}

	private function loadSC() {
		if ( !isset( $this->sc ) ) {
			$this->sc = CDatabase::table(
				$this->table_name )->fieldset();
		}
		return $this->sc;
	}

	public function search_init( $e ) {
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->set( array(
				"status"=>1,
			) )
			->exe( "request", "get" )
			->exe( "state", "set" );

		$this->event( "search" );
	}
	
	public function search( $e ) {

		$fs = $this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "state", "get" )
			->exe( "state", "clear" )
			->sot( "criteria" );

		$this->b_show_result = $this->sc->validate( "search" );

		if ( $this->b_show_result ) {
			$this->loadFS()
				->sel( "sr" )
				->sns( "rs" )
				->sot( "table" );
			$this->dt = new CDataTable( $this->sc );
		}

		$this->outputTemplate( "search" );
	}

	public function search_pb( $e ) { //-- [Search Button]
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "request", "get" )
			->exe( "state", "set" );

		$this->event( "search" );
	}

	public function search_pxy( $e ) { //-- [To non-search page]
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "request", "get" )
			->exe( "state", "set" );
	}

	public function search_ret( $e ) { //-- [From non-search page]
		CState::clear( "rs:*" );
		CState::clear( "_key:*" );

		$this->event( "search" );
	}

	public function edit_init( $e ) {
		$this->loadFS()
			->sel( "pkey" )
			->sns( "_key" )
			->exe( "request", "get" )
			->exe( "state", "set" );

		//-- find tab_key
		$tab_key = null;
		if ( isset($_REQUEST['tab_key']) ) {
			$tab_key = $_REQUEST['tab_key'];
			if ( !in_array( $tab_key, array(
				"basic",
				"slides",
				"options",
				"preview",
				"installation",
			))) {
				$tab_key = null;
			}
		}
		if ( $tab_key == null ) {
			$tab_key = "slides";
		}

		$this->event( "edit_{$tab_key}" );
	}

	public function edit_basic( $e ) {
		$this->edit_inp( $e, "basic" );
	}

	public function edit_slides( $e ) {
		$this->edit_inp( $e, "slides" );
	}

	public function edit_options( $e ) {
		$this->edit_inp( $e, "options" );
	}

	public function edit_preview( $e ) {
		$this->edit_inp( $e, "preview" );
	}

	public function edit_installation( $e ) {
		$this->edit_inp( $e, "installation" );
	}

	private function edit_inp( $e, $tab_key ) {
		$this->loadFS()
			->sel( "pkey" )
			->sns( "_key" )
			->exe( "state", "get" )

			->sel( "ne" )
			->exe( "db", "get" );

		$this->outputTemplate( $tab_key );
	}

	public function reg_init( $e ) {
		CEnv::loadLang("{$this->table_name}.init-form",$init_form);

		$fs = $this->loadFS()
			->sel( "addnew" )
			->set( $init_form );

		$this->event( "addnew_inp" );
	}

	public function addnew_inp( $e ) {
		$fs = $this->loadFS()
			->sel( "addnew" )
			->sns( "rs" )
			->sot( "input" );

		$this->outputTemplate( "addnew" );
	}

	public function addnew_done( $e ) {
		$fs = $this->loadFS()
			->sel( "addnew" )
			->sns( "rs" )
			->exe( "request", "get" );

		if ( $fs->validate( "insert" ) ) {

			//-- cookie
			$exp = time() + 60*60*24*365;
			setcookie("addnew.size", $fs->val('size'), $exp);
			setcookie("addnew.width", $fs->val('width'), $exp);
			setcookie("addnew.height", $fs->val('height'), $exp);

			if (( $fs->val("width") >= 300 ) &&
				( $fs->val("height") >= 300 )) {
				$visible = "onhover";
			} else{
				$visible = "hidden";
			}

			$dcx = array(
				"ver"=>"fss-2.14",
				"status"=>1,
				"title"=>$fs->val("title"),
				"width"=>$fs->val("width"),
				"height"=>$fs->val("height"),
				"trans-duration"=>1000,
				"pause-duration"=>1000,
				"loop"=>1,
				"effect-type"=>"fade",
				"rand-list"=>"",
				"clickable"=>0,
				"dest_url"=>"",
				"open_tab"=>0,
				"auto_start"=>1,
				"startbtn_visible"=>$visible,
				"dirnav_visible"=>$visible,
				"playnav_visible"=>$visible,
				"pager_visible"=>$visible,
				"sitems"=>array(
					array(
						"fkey"=>"",
						"clickable"=>0,
						"dest_url"=>"",
						"open_tab"=>0,
					)
				),
			);
			$dconf = json_encode($dcx);

			$fs
				->sel( "reg-save" )
				->set( array(
					'status' => 1,
					'dt_create' => date('Y-m-d H:i:s'),
					'dconf'=>$dconf,
				) )
				->exe( "db", "add" );

			$this->event( "edit_init" );
		} else {
			$this->event( "addnew_inp" );
		}
	}

	public function del_multi( $e ) {
		$fs = $this->loadFS();

		if ( CDataTable::getSelRec( $selrec ) ) {
			foreach( $selrec as $id ) {
				$this->delSShow($id);
			}
			CUInfo::addInfo( $fs->lng( "deleted" ) );
		}

		$this->event( "search_ret" );
	}

	private function delSShow( $sshow_id ) {

		$tbl = CDatabase::table( $this->table_name );

		$cond = array();
		$cond[] = array("sshow_id","=",$sshow_id);
		$rs = $tbl->findRec( array(
			"dconf",
		),$cond);

		if ( $rs ) {

			$dconf = $rs['dconf'];
			$dcx = json_decode( $dconf, true );

			//-- delete pirctures
			foreach( $dcx['sitems'] as &$sitem ) {
				CPic::del($sitem['fkey']);
			}

			//-- delete cache
			CSShow::deleteCache($sshow_id);

			//-- delete record
			$tbl->deleteRec( array(
				array("sshow_id","=",$sshow_id),
			) );
		}
	}

	private static function procSItems( &$sitems_old, &$sitems_new ) {

		//-- build old fkey list
		$fkey_old = array();
		foreach( $sitems_old as $rs ) {
			$fkey_old[] = $rs['fkey'];
		}

		//-- build new fkey list
		$fkey_new = array();
		foreach( $sitems_new as $rs ) {
			$fkey_new[] = $rs['fkey'];
		}

		//-- delete pics
		$del_list = array_diff($fkey_old,$fkey_new);
		foreach( $del_list as $fkey ) {
			CPic::del($fkey);
		}

		//-- delete from tmp files
		$del_list = array_diff($fkey_new,$fkey_old);
		CTmpFile::del('pic',$del_list);
	}

	private static function procArrTrans( &$dcx_old, &$dcx_new, $ls ) {
		foreach( $ls as $f ) {
			$dcx_old[$f] = $dcx_new[$f];
		}
	}

	private function validate( $tab_key, $fs ) {
		$fs->sel( $tab_key )->sns('rs');
		if ( $fs->validate( "update" ) ) {
			return null;
		} else {
			$emx = CUInfo::get( "error:rs:*" );
			foreach( $emx as &$em ) {
				$em = htmlspecialchars( $em );
			}
			return implode( "\n", $emx );
		}
	}

	public function save( $e ) {
		$errmsg = null;
		$sshow_id = intval($_REQUEST['sshow_id']);
		$tab_key = $_REQUEST['tab_key'];
		$dconf_new = $_REQUEST['dconf'];
		$dcx_new = json_decode($dconf_new,true);

		$fs = $this->loadFS()
			->set($dcx_new);

		$errmsg = self::validate($tab_key,$fs);
		if ( !$errmsg ) {

			$ls_basic = array(
				'status',
				'title',
				'width',
				'height',
			);

			$ls_options = array(
				"trans-duration",
				"pause-duration",
				"loop",
				"effect-type",
				"rand-list",
				"clickable",
				"dest-url",
				"open-tab",
				"auto_start",
				"startbtn_visible",
				"playnav_visible",
				"dirnav_visible",
				"pager_visible",
			);

			$rs = CDatabase::table( $this->table_name )
				->findRec(
					array("dconf"),
					array(array("sshow_id","=",$sshow_id))
				);

			$dconf_old = $rs["dconf"];
			$dcx_old = json_decode($dconf_old,true);

			if ( $tab_key == 'basic' ) {
				self::procArrTrans($dcx_old,$dcx_new,$ls_basic);
			}

			if ( $tab_key == 'slides' ) {
				self::procSItems($dcx_old['sitems'],$dcx_new['sitems']);
				$dcx_old['sitems'] = $dcx_new['sitems'];
			}

			if ( $tab_key == 'options' ) {
				self::procArrTrans($dcx_old,$dcx_new,$ls_options);
			}

			//-- save
			$dconf = json_encode($dcx_old);
			CDatabase::table( $this->table_name )
				->updateRec(
					array(
						"status"=>$dcx_old['status'],
						"title"=>$dcx_old['title'],
						"dconf"=>$dconf,
					),
					array(array("sshow_id","=",$sshow_id))
				);

			//-- create cache file
			CSShow::render($sshow_id);

		}

		//-- ajax response
		$res = array();
		$res['result'] = 'OK';
		if ( $errmsg ) {
			$res['error'] = $errmsg;
		} else {
			$res['error'] = '';
		}
		echo json_encode($res);
	}

	public function load( $e ) {
		$sshow_id = $_REQUEST['sshow_id'];

		$rs = CDatabase::table( $this->table_name )
			->findRec(
				array("dconf"),
				array(array("sshow_id","=",$sshow_id))
			);
		$dconf = json_decode($rs['dconf'],true);

		$res = array();
		$res['result'] = 'OK';
		$res['dconf'] = $dconf;
		echo json_encode($res);
	}

	public function upload_pic( $e ) {
		$sshow_id = $_REQUEST['sshow_id'];
		$mratio = $_REQUEST['mratio'];

		CEnv::loadConfig( "sshow.pic", $cfg_upload );

		$rs = CDatabase::table( $this->table_name )
			->findRec(
				array("dconf"),
				array(array("sshow_id","=",$sshow_id))
			);
		$dconf = json_decode($rs['dconf'],true);
		$width = $dconf['width'];
		$height = $dconf['height'];

		//-- allowed file extension
		$cfg_upload['allowed-fileext'] = 'png, jpeg, jpg, gif';

		//-- max image width & height for midium
		$cfg_upload['sizes'] = array(
			'a' => array(
				'mode'=> ( $mratio == 1 ) ? 'pad' : 'map',
				'w'=>$width,
				'h'=>$height,
			),
			'm' => array( 
				'mode'=>'fit',
				'w'=>200,
				'h'=>200,
			),
			's' => array( 
				'mode'=>'fit',
				'w'=>50,
				'h'=>50,
			),
		);

		$obj = new CPicUpload(array(
			'url_storage' => CPic::url(),
			'path_storage' => CPic::path(),
			'allowed_fileext' => $cfg_upload['allowed-fileext'],
			'max_filesize' => $cfg_upload['max-filesize'],
			'sizes' => $cfg_upload['sizes'],
		));
		$obj->run();
	}

	public function import_init( $e ) {
		$this->outputTemplate( "import" );
	}

	public function import_fss( $e ) {
		CEnv::loadConfig('fss.import',$cfg_import);
		$obj = new CFssImport(array(
			'max_filesize' => $cfg_import['max-filesize'],
			'allowed_fileext' => "fss",
		));
		$obj->run();
	}

	public function import_done( $e ) {
		$fs = $this->loadFS();
		CUInfo::addInfo( $fs->lng( "imported" ) );
		$this->event( "search_ret" );
	}

	public function export_fss( $e ) {
		CDataTable::getSelRec( $selrec );
		asort($selrec);
		CFssExport::export( $selrec );
	}

	public function dlcode( $e ) {
		$sshow_id = intval($_REQUEST['sshow_id']);
		if ( $sshow_id != 0 ) {

			$rs = CDatabase::table( $this->table_name )
				->findRec(
					array("title"),
					array(array("sshow_id","=",$sshow_id))
				);

			$title = "";
			if ( $rs ) {
				$title = $rs['title'];
			}

			CDownloadCode::emit($sshow_id,$title);
		}
	}
}

?>