/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	CPopup = {};
	CPopup.prototype = {

		base : tScope.CObject

	}

	tScope.CPopup = CPopup;

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	CModalDialog = {};
	CModalDialog.prototype = {

		base : tScope.CPopup,

		getViewport : function() {
			var win = $(window);
			return {
				'x':win.scrollLeft(),
				'y':win.scrollTop(),
				'w':win.width(),
				'h':win.height()
			};
		},

		setup : function() {

			if (!( 'class_dlg' in this )) {
				this.class_dlg = 'CDialog-dlg';
			}

			if (!( 'class_overlay' in this )) {
				this.class_overlay = 'CDialog-overlay';
			}

			var _this = this;
			if (!( 'selector_open' in this )) {
				$( this.selector_open ).click( function(e){
					e.preventDefault();

					if (!( 'content' in this )) {
						this.content = $( '#' + $(this).attr( 'dlg-content' ) )
							.clone()
							.attr( 'id', '' )
							.show();
					}

					_this.open();
				});
			}
		},

		onWindowResized : function() {
			this.overlay
				.css( "left", "0" )
				.css( "top", "0" )
				.css( "width", $(window).width() )
				.css( "height", $(window).height() );

			var vp = this.getViewport();

			var dp = {
				x:0,
				y:0,
				w:this.dlg.outerWidth(),
				h:this.dlg.outerHeight()
			}

			if ( vp.w <= dp.w ) {
				dp.x = vp.x;
			} else {
				dp.x = vp.x + ( vp.w - dp.w ) / 2;
			}

			if ( vp.h <= dp.h ) {
				dp.y = vp.y;
			} else {
				dp.y = vp.y + ( vp.h - dp.h ) / 2;
			}

			this.dlg.css({
				"left" : dp.x + "px",
				"top" : dp.y + "px"
			})
		},

		open : function() {

			var _this = this;

			this.dlg = $( "<div>" )
				.attr( "class", this.class_dlg )
				.css( "position", "fixed" )
				.appendTo( $('body') );

			this.dlg.css({
				"left" : "-10000px",
				"top" : "-10000px"
			})
			.show()
			.append( this.content );

			var _this = this;
			this.dlg.find( '.btn-ok' )
				.click( function(e){
					_this.close();
				});

			this.dlg.find( '.btn-cancel' )
				.click( function(e){
					_this.close();
				});

			this.overlay = $( "<div>" )
				.attr( "class", this.class_overlay )
				.css( "position", "fixed" )
				.css( "z-index", this.dlg.css( "z-index" ) - 1 )
				.click( function(e) {
					_this.close();
				})
				.appendTo( $('body') );

			this.resize_handler = function() {
				_this.onWindowResized();
			};
			this.resize_handler();
			$( window ).bind( "resize", this.resize_handler );

			this.overlay.show();

			var move = { x:0, y:20 };
			this.dlg.css({
				"left" : "-=" + move.x + "px",
				"top" : "-=" + move.y + "px",
				"opacity": 0.0
			})
			.animate({
				left: "+=" + move.x + "px",
				top: "+=" + move.y + "px",
				opacity: 1.0
			}, 500 );

			if ( 'timeout' in this ) {
				setTimeout(function(){
					_this.close();
				},this.timeout);
			}
		},

		close : function() {
			$( window ).unbind( "resize", this.resize_handler );

			this.overlay.fadeOut(function(){
				$(this).remove();
			});

			var move = { x:0, y:20 };
			this.dlg
				.animate({
					left: "+=" + move.x,
					top: "+=" + move.y,
					opacity: 0.0
				}, 500, function(){
					$(this).html('');
					$(this).remove();
				});
		}
	};

	tScope.CModalDialog = CModalDialog;

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	CMsgBox = {};
	CMsgBox.prototype = {

		base : tScope.CModalDialog,

		init: 'setup',

		setup : function(){
			this.content = "<div style='text-align:left;'>" +
				this.content.replace( /\n/g, "<br/>" ) +
				"</div>";
			this.$setup();
		}
	}

	tScope.CMsgBox = CMsgBox;

	tScope.MsgBox = function( msg ) {
		var msgbox = tScope.create(tScope.CMsgBox,{
			content:msg
		});
		msgbox.open();
	}

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
/*
	CConfDialog = {};
	CConfDialog.prototype = {

	}

	$(document).ready(function(){
		var dlg = new CConfDialog({
			selector_open:".open-confdlg",
			class_dlg:"-f0p-dlg",
			class_overlay:"-f0p-overlay"
		});
	});
*/

}(jQuery));
