/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CDocSShow = {};
	CDocSShow.prototype = {

		base : tScope.CSignal,
		event: ['newSItem'],
		init: 'setup',

		setup : function(){
			tScope.CPic.setUrlPic(this.conf.url_pic);
			this.url_server = document.URL;
			this.sshow_id = this.conf.sshow_id;
			this.view = tScope.create(this.view_class,{
				doc:this,
				conf:this.conf
			});
			this.view.setup();
		},

		getFormFields : function(tab_key){
			switch( tab_key ) {
			case "basic":
				return [
					"status",
					"title",
					"width",
					"height",
				];

			case "slides":
				return [
				];

			case "options":
				return [
					"trans-duration",
					"pause-duration",
					"loop",
					"effect-type",
					"rand-list",
					"clickable",
					"dest-url",
					"open-tab",
					"auto_start",
					"startbtn_visible",
					"playnav_visible",
					"dirnav_visible",
					"pager_visible"
				];
			}
		},

		createSItem : function(){
			var props = {
				view:this.view,
				pdata:{
					fkey:"",
					clickable:0,
					dest_url:"",
					open_tab:0
				}
			}
			return tScope.create(tScope.CSItem,props);
		},

		getSItemsList : function() {
			var rx = [];
			var ls = this.view.getJqoPanels();
			ls.each(function(){
				rx.push($(this).data('tobj').sitem);
			});
			return rx;
		},

		setSItemsData : function( sitems ) {
			for( var i=0; i < sitems.length;  i++ ){
				var props = {};
				props.view = this.view;
				props.pdata = sitems[i];
				var sitem = tScope.create(tScope.CSItem,props);
				this.trigger('newSItem',sitem);
			}
		},

		getSItemsData : function() {
			if ( this.view.selected_thumb ) {
				this.view.selected_thumb.sitem.commitUserInput();
			}

			var fields = [
				"fkey",
				"trans-duration",
				"pause-duration",
				"effect-type",
				"clickable",
				"dest-url",
				"open-tab"
			];
			var sitems = this.getSItemsList();
			var ret = [];
			for( var i=0; i < sitems.length;  i++ ){
				var rx = {};
				var sitem = sitems[i];
				for( var f=0; f<fields.length; f++ ) {
					var fn = fields[f];
					rx[fn] = sitem.pdata[fn];
				}
				ret.push(rx);
			}
			return ret;
		},

		load : function(tab_key){
			var _this = this;
			var data = {};
			data['_cmd'] = "sshow/crud/load";
			data['sshow_id'] = this.sshow_id;
			data['tab_key'] = tab_key;
			this.send(data,false,function(res){
				var dconf = res['dconf'];
				this.ver = dconf['ver'];
				tScope.CForm.set("fss",dconf,this.getFormFields(tab_key));
				if ( tab_key == "slides") {
					this.setSItemsData(dconf['sitems']);
				}
			});
		},

		save : function(tab_key,done) {
			dconf = {};
			dconf['ver'] = this.ver;
			tScope.CForm.get("fss",dconf,this.getFormFields(tab_key));
			if ( tab_key == "slides") {
				dconf['sitems'] = this.getSItemsData();
			}
			var data = {};
			data['_cmd'] = "sshow/crud/save";
			data['sshow_id'] = this.sshow_id;
			data['tab_key'] = tab_key;
			data['dconf'] = JSON.stringify(dconf);

			this.send(data,true,function(res){
				var b = ( res.error == '' );
				done(b);
				if ( !b ) {
					alert(res.error);
				}
			});
		},

		ajaxpp : function( data ) {
			var s_reload = "<!--@reload-->";
			if ( data.substring(0,s_reload.length) == s_reload ) {
				location.reload(true);
			}
		},

		send : function( data_in, async, complete ) {
			var _this = this;

			$.ajax({
				type: 'POST',
				url: this.url_server,
				data: data_in,
				success: function(data_out) {
					_this.ajaxpp(data_out);
					var res = eval('(' + data_out + ')');
					if ( res.result == 'OK' ) {
						complete.call(_this,res);
					} else {
						alert( res.result );
					}
				},
				dataType: "text",
				async:async
			});
		}
	}

	tScope.CDocSShow = CDocSShow;

}(jQuery));
