/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CFileUploadHtml5 = {};
	CFileUploadHtml5.prototype = {

		base : tScope.CObject,
		init: 'setup',

		show : function() {
			$(this.selector).show();
		},

		sendForm : function( form_data ) {

			xhr = new XMLHttpRequest();

			var _this = this;
			if ( 'onXhrProgress' in this ) {
				xhr.upload.addEventListener("progress", function(e) {
					if (e.lengthComputable) {
						_this['onXhrProgress'](e);
					}
				}, false);
			}

			if ( 'onXhrLoadStart' in this ) {
				xhr.upload.addEventListener("loadstart", function(e){
					_this.onXhrLoadStart(e);
				}, false);
			}

			if ( 'onXhrLoad' in this ) {
				xhr.upload.addEventListener("load", function(e){
					_this.onXhrLoad(e);
				}, false);
			}

			xhr.onreadystatechange = function() {
				_this.onXhrReadyStateChange(xhr);
			}

			xhr.open("POST", this.url_server);
			//xhr.overrideMimeType('text/plain; charset=x-user-defined-binary');
			xhr.send(form_data);
		},

		showErrMsg : function( msg ) {
			tScope.MsgBox( msg );
			//alert( msg );
		},

		getFileSizeStr : function( bytes ) {
			var bsize;

			if ( bytes < 1000 ) {
				bsize = bytes + " bytes";
			} else if ( bytes < 1000 * 1000 ) {
				bsize = ( bytes / 1000 ).toFixed(2) + " KB";
			} else {
				bsize = ( bytes / ( 1000 * 1000 ) ).toFixed(2) + " MB";
			}

			return bsize;
		},

		validate : function( files ) {

			//-- file count
			//if (files.length > max_file_count) {
			//	showErrMsg( "max file count exceeded" );
			//	return false;
			//}

			for( var idx = 0; idx < files.length; idx++ ) {
				var file = files[idx];

				//-- file size
				if ( 'max_filesize' in this ) {
					if (file.size > this.max_filesize) {
						var msg = "File is too big";
						msg += "\n[" + file.name + "]";
						msg += "\n(" + this.getFileSizeStr(file.size) + ")";
						this.showErrMsg( msg );
						return false;
					}
				}
/*
				//-- file type
				if (!file.type.match('image.*')) {
					var msg = "Invalid file type";
					msg += "\n[" + file.type + "]";
					msg += "\n( Please upload picture files )";
					this.showErrMsg( msg );
					return false;
				}
*/
			};

			return true;
		},

		processFiles : function( files, form ) {

			if ( !this.validate( files ) ) {
				return false;
			}

			if ( form == null ) {
				form_data = new FormData();
			} else {
				form_data = new FormData(form)
			}

			for( k in this.params ) {
				var v = this.params[k];
				form_data.append( k, v );
			}

			$.each(files, function( index, file ) {
				form_data.append( "user-upfile" + index, file );
			});

			this.sendForm(form_data);

			return true;
		},

		setup : function () {
			var _this = this;

			this.dropzone = $(this.selector);

			//-- drag and drop
			$.event.props.push('dataTransfer');
			this.dropzone.bind('drop', function(e) {
				if ( 'initProcess' in _this ) {
					_this.initProcess();
				}

				_this.processFiles(
					e.dataTransfer.files,
					null
				);
			});

			//-- select file
			$(this.selector + ' .fileup-input').change(function(e){
				if ( 'initProcess' in _this ) {
					_this.initProcess();
				}

				if ( !_this.processFiles(
					$(this).get(0).files,
					$(this).parents('form').get(0)
				)){
					$(this).parents('form').get(0).reset();
				}
			});
		}
	}

	tScope.CFileUploadHtml5 = CFileUploadHtml5;

}(jQuery));
