/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CForm = {

		getForm : function( fn ) {

			if ( typeof fn === 'undefined' ) {
				fn = 'form-main';
			}

			return $('form.' + fn );
		},

		getType : function( form, name ) {
			var jqo = form.find('input[name="'+name+'"]');
			if ( jqo.length ) {
				return jqo.attr("type");
			}
			var jqo = form.find('select[name="'+name+'"]');
			if ( jqo.length ) {
				return "select";
			}
			var jqo = form.find('textarea[name="'+name+'"]');
			if ( jqo.length ) {
				return "textarea";
			}
		},

		get : function( ns, px, ls, fn ) {

			var form;
			if ( typeof fn === 'undefinfed' ) {
				form = this.getForm();
			} else {
				form = this.getForm(fn);
			}

			if ( typeof ls === 'undefinfed' ) {
				for( name in px ) {
					px[name] = this._get(form,ns+":"+name);
				}
			} else {
				for( var i=0; i<ls.length; i++ ) {
					var name = ls[i];
					px[name] = this._get(form,ns+":"+name);
				}
			}
		},

		_get : function( form, name, type ) {

			if ( typeof type === 'undefined' ) {
				type = this.getType(form,name);
			}

			var v = '';
			switch( type ) {
			case "text":
				v = form
					.find('input[name="' + name + '"]')
					.val();
				break;
			case "radio":
				v = form
					.find('input:radio[name="' + name + '"]:checked')
					.val();
				break;
			case "checkbox":
				var jqo = form.find('input:checkbox[name="' + name + '"]');
				if ( jqo.length == 1 ) {
					v = jqo.is(':checked') ? 1 : 0;
				} else {
					var rx = [];
					jqo.each(function(){
						if ( $(this).is(':checked') ) {
							rx.push($(this).val());
						}
					});
					v = rx.join(',');
				}
				break;
			case "select":
				v = form
					.find('select[name="' + name + '"] option:selected')
					.val();
				break;
			case "textarea":
				v = form
					.find('textarea[name="' + name + '"]')
					.val();
				break;
			}

			return v;
		},

		set : function( ns, px, ls, fn ) {

			var form;
			if ( typeof fn === 'undefinfed' ) {
				form = this.getForm();
			} else {
				form = this.getForm(fn);
			}

			if ( typeof ls === 'undefined' ) {
				for( name in px ) {
					this._set(form,ns+":"+name,px[name]);
				}
			} else {
				for( var i=0; i<ls.length; i++ ) {
					var name = ls[i];
					this._set(form,ns+":"+name,px[name]);
				}
			}
		},

		_set : function( form, name, val, type ) {

			if ( typeof type === 'undefined' ) {
				type = this.getType(form,name);
			}

			if ( typeof val === 'undefined' ) {
				val = '';
			}

			switch( type ) {
			case "text":
				form
					.find('input[name="' + name + '"]')
					.val(val);
				break;
			case "radio":
				form
					.find('input:radio[name="' + name + '"][value="' + val + '"]')
					.attr('checked', 'checked');
				break;
			case "checkbox":
				var jqo = form.find('input:checkbox[name="' + name + '"]');
				if ( jqo.length == 1 ) {
					jqo.prop('checked',val);
				} else {
					var rx = val.split(",");
					jqo.each(function(){
						var b = $.inArray($(this).val(),rx) == -1 ? 0 : 1;
						$(this).prop('checked',b);
					});
				}
				break;
			case "select":
				form
					.find('select[name="' + name + '"]')
					.val(val);
				break;
			case "textarea":
				form
					.find('textarea[name="' + name + '"]')
					.val(val);
				break;
			}
		}
	};

	tScope.CForm = CForm;

}(jQuery));
