/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	function CProgressBar( props ) {
		tScope.extend( tScope.CObject, this, props );
	}

	CProgressBar.prototype = {
		start : function() {

			this.status = $( '<span>' )
				.attr( 'class', 'progressbar-status' );

			this.percentage = $( '<span>' )
				.attr( 'class', 'progressbar-percentage' );

			this.indicator_inner = $( '<div>' )
				.attr( 'class', 'progressbar-indicator-inner' )
				.append( this.status )
				.append( this.percentage );

			this.indicator = $( '<div>' )
				.attr( 'class', 'progressbar-indicator' )
				.append( this.indicator_inner )

			this.meter = $( '<div>' )
				.attr( 'class', 'progressbar-meter' )
				.css({
					width:0
				});

			this.container = $( this.selector )
				.attr( 'class', 'progressbar-container' )
				.html('')
				.append( this.indicator )
				.append( this.meter )
				.show();

			this.perc = 0;
			this.progress( 0 );

			var _this = this;
			var idx = 0;
			var blink = function(){
				if ( _this.perc < 100 ) {
					idx++;
					if ( idx % 2 == 0 ) {
						_this.status.fadeIn();
						setTimeout( blink, 1000 );
					} else {
						_this.status.fadeOut();
						setTimeout( blink, 100 );
					}
				}
			}
			blink();
		},

		progress : function( curr, total ) {
			if ( typeof total == 'undefined' ) {
				total = 1;
			}

			var perc;
			if ( curr == total ) {
				perc = 100;
				status = '';
			} else {
				perc = Math.round((curr * 100) / total);
				status = this.progress_msg;
			}
			this.status.html( status );
			this.percentage.html( perc + '%' );

			var w = Math.round((perc * this.container.width()) / 100 );
			if ( perc - this.perc > 50 ) {
				this.meter.animate({
					width: w + 'px'
				}, 500);
			} else {
				this.meter.css({
					width: w + 'px'
				});
			}
			this.perc = perc;
		},

		end : function(){
			this.progress(1,1);
			var _this = this;
			setTimeout( function(){
				_this.container.html('').fadeOut();
			}, 300 );
		},

		hide : function(){
			this.container.html('').hide();
		}
	}

	tScope.CProgressBar = CProgressBar;

}(jQuery));
