/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CAutoScroll = {};
	CAutoScroll.prototype = {

		base: tScope.CObject,
		init: 'setup',

		setup : function() {
			this.x_coef = 0.2;
			this.speed_ms = 10;
			this.x_activate = 5;//pixel
			this.x_deactivate = this.x_activate * 2;//pixel
		},

		begin : function( jqo_moving, pageX, pageY ) {
			this.pageX = pageX;
			this.pageY = pageY;

			this.speed = 0;
			this.timer_id = null;
			this.jqo_moving = jqo_moving;
			this.rel_panel_left = jqo_moving.offset().left - pageX;
			this.rel_panel_right = jqo_moving.offset().left + jqo_moving.width() - pageX;
			this.frame_left = this.jqo_container.offset().left;
			this.frame_right = this.jqo_container.offset().left + this.jqo_container.width();
			this.x_scroll_max = this.jqo_board.outerWidth(true)
				- this.jqo_container.width() * 0.5;
		},

		done : function() {
			if ( this.timer_id != null ) {
				clearInterval( this.timer_id );
				this.timer_id = null;
			}
		},

		mouseMove : function( pageX, pageY ) {
			this.pageX = pageX;
			this.pageY = pageY;

			if ( this.speed == 0 ) {
				this.checkStatus();
				if ( this.speed != 0 ) {
					var _this = this;
					this.timer_id = setInterval(
						function(){ _this.scroll(); },
						this.speed_ms );
				}
			} else {
				this.checkStatus();
				if ( this.speed == 0 ) {
					this.done();
				}
			}
		},

		scroll : function() {
			var dx = this.speed * this.x_coef;
			var new_scroll_left = this.jqo_container.scrollLeft() + dx;
			if ( new_scroll_left < this.x_scroll_max ) {
				this.jqo_container.scrollLeft( new_scroll_left, 0 );
				this.scroll_board.mousemove(this);
			}
		},

		checkStatus : function() {
			var frame_left = this.frame_left;
			var frame_right = this.frame_right;
			var panel_left = this.pageX + this.rel_panel_left;
			var panel_right = this.pageX + this.rel_panel_right;
			var d;

			d = ( panel_left - frame_left ) - this.x_activate;
			if ( d < 0 ) {
				this.speed = d;
				return;
			}

			d = this.x_activate - ( frame_right - panel_right );
			if ( d > 0 ) {
				this.speed = d;
				return;
			}

			d = panel_left - frame_left - this.x_deactivate;
			if ( d > 0 ) {
				this.speed = 0;
				return;
			}

			d = ( this.x_deactivate - ( frame_right - panel_right ) )
			if ( d < 0 ) {
				this.speed = 0;
				return;
			}
		}
	}

	CScrollBoard = {};
	CScrollBoard.prototype = {

		base : tScope.CObject,

		setup : function(){

			this.jqo_container
				.mouseenter( function(){
					document.onselectstart = function(){ return false; }
				})
				.mouseleave( function(){
					document.onselectstart = function(){ return true; }
				});

			// frame should have 'relative' & 'overflow-x' [IE7 bug fix]
			this.jqo_container.css( 'overflow-x', 'scroll' );
			this.jqo_container.css( 'overflow-y', 'hidden' );
			this.jqo_container.css( 'position', 'relative' );
			this.jqo_board.css( 'position', 'relative' );

			this.autoscroll = tScope.create(CAutoScroll,{
				scroll_board:this,
				jqo_container:this.jqo_container,
				jqo_board:this.jqo_board
			});
		},

		scrollTo : function(jqo) {
			var dx = this.jqo_board.offset().left -
				jqo.offset().left;
			this.jqo_container.scrollLeft( dx, 0 );
		},
/*
		cloneIDSafe : function( org_obj, new_id ) {
			//-- clone object with ID ( for IE bug )
			var org_id = org_obj.attr('id');
			org_obj.attr( 'id', 'id_temporary' );
			var new_obj = org_obj.clone();
			if ( new_id == null ) {
				new_obj.removeAttr( 'id' );
			} else {
				new_obj.attr( 'id', new_id );
			}
			org_obj.removeAttr( 'id' );
			return new_obj;
		},
*/
		mousemove : function( e ) {
			var jqo_board = this.jqo_board;
			var jqo_moving = this.jqo_moving;
			var jqo_space = this.jqo_space;

			//-- move panel
			jqo_moving.offset({
				"top": jqo_moving.offset().top,
				"left": e.pageX - this.rel_pos_x
			});

			//-- move space panel
			var pos_x = jqo_board.offset().left;
			var x = e.pageX - pos_x - this.rel_pos_x;
			var xw = x + jqo_moving.width();

			var pdiv = 3;
			if ( x < jqo_space.offset().left - pos_x ) {
				jqo_board.children().each( function( idx ) {
					var jqo = $(this);
					if ( jqo.is( jqo_space ) ) {
						return false;
					} else if ( !jqo.is( jqo_moving ) ) {
						var w = jqo.width();
						var x1 = jqo.offset().left - jqo_board.offset().left;
						if ( x < x1+w*1/pdiv ) {
							jqo.before( jqo_space );
							return false;
						}
					}
				});
			} else {
				$.each( jqo_board.children().get().reverse(), function( idx ) {
					var jqo = $(this);
					if ( jqo.is( jqo_space ) ) {
						return false;
					} else if ( !jqo.is( jqo_moving ) ) {
						var w = jqo.width();
						var x1 = jqo.offset().left - jqo_board.offset().left;
						if ( xw > x1+w*(pdiv-1)/pdiv ) {
							jqo.after( jqo_space );
							return false;
						}
					}
				});
			}
		},

		mouseup : function( e ) {
			var jqo_board = this.jqo_board;
			var jqo_moving = this.jqo_moving;
			var jqo_space = this.jqo_space;

			jqo_moving.css( 'position', 'static' );
			jqo_moving.css( 'z-index', 1 );
			jqo_moving.css( 'opacity', 1.0 );
			jqo_space.before( jqo_moving );
			jqo_space.remove();
			this.jqo_moving = undefined;
		},

		mousedown : function( e, jqo_moving ) {

			//-- setup a dummy panel
			/*
			this.jqo_space = this.cloneIDSafe(
				jqo_moving,
				null
			);*/
			this.jqo_space = jqo_moving.clone();

			var jqo_board = this.jqo_board;
			var jqo_space = this.jqo_space;

			jqo_space.html( '' );
			jqo_space.css( 'background-color', '#f0f0f0' );
			jqo_space.css( 'width', jqo_moving.width() );
			jqo_space.css( 'height', jqo_moving.height() );
			jqo_space.css( 'z-index', 1 );
			jqo_moving.after( jqo_space );

			//-- keep offset in static mode
			var offset = jqo_moving.offset();
			this.rel_pos_x = e.pageX - offset.left;

			//-- [BEGIN] Shift to Absolute Mode
			jqo_moving.css( 'position', 'absolute' );
			jqo_moving.css( 'z-index', 10000 );
			this.jqo_moving = jqo_moving;
			//-- [END] Shift to Absolute Mode

			//-- set offset in absolute mode
			jqo_moving.offset( offset );

			//-- semi-transparent
			jqo_moving.css( 'opacity', 0.5 );
		},

		addMouseCapture : function( e, jqo_moving ) {
			e.preventDefault();
			if (e.which != 1) return false; 

			var _this = this;

			//-- [BEGIN] Mouse Move
			var h_mousemove = function( e ) {
				e.preventDefault();
				if (e.which != 1) return false; 
				if ( _this.jqo_moving == undefined ) return false;

				//-- auto scroll
				_this.autoscroll.mouseMove( e.pageX, e.pageY );

				//-- mousemove core
				_this.mousemove(e);
			};
			//-- [END] Mouse Move

			//-- [BEGIN] Mouse Up
			var h_mouseup = function( e ) {
				e.preventDefault();
				if (e.which != 1) return false; 
				if ( _this.jqo_moving == undefined ) return false;

				//-- disable autoscroll
				_this.autoscroll.done();

				//-- enable text selection
				//document.onselectstart = function(){ return true; }

				//-- enable right click
				$('body').unbind( 'contextmenu' );

				//-- release mouse
				$(document).unbind( "mousemove", h_mousemove );
				$(document).unbind( "mouseup", h_mouseup );

				//-- mouseup core
				_this.mouseup(e);
			};
			//-- [END] Mouse Up

			//-- capture mouse
			$(document).mousemove( h_mousemove );
			$(document).mouseup( h_mouseup );

			//-- disable right click
			$('body').bind('contextmenu', function(e) {
				return false;
			});

			//-- disable text selection
			//document.onselectstart = function(){ return false; }

			//-- fix chrome cursor problem while dragging
			if ( e.originalEvent.preventDefault ) {
				e.originalEvent.preventDefault();
			}

			//-- init autoscroll
			this.autoscroll.begin( jqo_moving, e.pageX, e.pageY );

			//-- mousedown core
			this.mousedown(e,jqo_moving);
		}
	}

	tScope.CScrollBoard = CScrollBoard;

}(jQuery));
