/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CTTab = {};
	CTTab.prototype = {

		base : tScope.CObject,
		init: 'setup',

		isIE7 : function(){
			if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) {
 				var ieversion=new Number(RegExp.$1);
				return (ieversion <= 7);
			}
			return false;
		},

		getSelectedTabKey : function(){
			if ( this.selected_tab ) {
				return this.selected_tab.data('tab-key');
			} else {
				return null;
			}
		},

		select : function( tab_key ){

			//-- activated
			if ( 'onActivated' in this ) {
				if ( !this.onActivated(tab_key) ) {
					return;
				}
			}

			var tab = this.tabs[tab_key]['tab'];

			var content = null;
			if ( 'content' in this.tabs[tab_key] ) {
				content = this.tabs[tab_key]['content'];
			}

			//-- deselected
			if ( this.selected_tab ) {
				if ( 'onDeselect' in this ) {
					this.onDeselect(this.getSelectedTabKey());
				}
				this.jqo.children('.ttt-content').hide();
				this.jqo_tabs.children('.ttt-tab').removeClass( 'ttt-tab-sel');
			}

			if ( content != null ) {
				content.show();
			}
			tab.addClass('ttt-tab-sel');

			//-- selector
			tab.data('ttt-option').prop('selected',true);

			//-- selected
			this.selected_tab = tab;
			if ( 'onSelect' in this ) {
				this.onSelect(tab_key);
			}
		},

		moveFocus : function(pos,jqo) {
			if ( pos == 'L' ) {
				var jqo = jqo.prev('.ttt-tab');
				if ( jqo.length ) {
					jqo.find('span').focus();
				}
			}
			if ( pos == 'R' ) {
				var jqo = jqo.next('.ttt-tab');
				if ( jqo.length ) {
					jqo.find('span').focus();
				}
			}
		},

		draw : function() {
			var b_selector;
			var tabs = this.jqo_tabs.children('.ttt-tab');
			if ( this.isIE7() ) {
				b_selector = false;
			} else {
				tabs.show();
				var first = tabs.first();
				var last = this.jqo_tab_dummy;
				b_selector = ( first.offset().top < last.offset().top );
			}

			if ( b_selector ) {
				tabs.hide();
				this.jqo_tab_selector_tab.show();
			} else {
				tabs.show();
				this.jqo_tab_selector_tab.hide();
			}
		},

		onContainerResized : function() {
			this.draw();
		},

		setup : function(){

			var _this = this;
			this.selected_tab = null;

			//--prepend ttt-tabs
			this.jqo.prepend( $("<div>")
				.attr('class','ttt-tabs')
			);

			//-- build tabs
			this.jqo_tabs = this.jqo.children('.ttt-tabs');

			this.jqo_tab_selector = $('<select>')
				.attr('class','ttt-tab-selector')
				.css({
					'margin-top':'3px'
				});

			if (!( 'tabs' in this )) {
				this.tabs = {};
			}

			this.jqo_contents = this.jqo.children('.ttt-content');
			this.jqo_contents.each(function(idx,ele){
				var key = $(ele).attr('tab-key');
				if (!( key in _this.tabs )) {
					_this.tabs[key] = {
						'tab-label':$(ele).attr('tab-label')
					};
				};

				_this.tabs[key]['content'] = $(ele);
			});

			for( key in this.tabs ) {
				var tc = this.tabs[key];

				var tab = $('<div>')
					.attr('class','ttt-tab')
					.data('tobj',this)
					.data('tab-key',key)
					.append( $("<span>")
						.attr('class','ttt-label')
						.attr('tabindex',0)
						.html(tc['tab-label'])
						.keyup(function(e){ 
							e.preventDefault();
							var jqo = $(this).parents('.ttt-tab');
							var code = e.which;
							if( code==32 ) {
								jqo.data('tobj').select(jqo.data('tab-key'));
							} else if ( code==37 ) {//left
								jqo.data('tobj').moveFocus('L',jqo);
							} else if ( code==39 ) {//right
								jqo.data('tobj').moveFocus('R',jqo);
							}
						})
					);

				tc['tab'] = tab;

				var option = $('<option>')
					.attr('class','ttt-option')
					.data('tab-key',key)
					.html(tc['tab-label']);

				tab.data('ttt-option',option);
				_this.jqo_tabs.append( tab );
				_this.jqo_tab_selector.append( option );
			};

			//-- tab selector tab
			this.jqo_tab_selector_tab = $('<div>')
				.attr('class','ttt-tab-selector-tab')
				.append( this.jqo_tab_selector );
			this.jqo_tabs.append( this.jqo_tab_selector_tab );

			//-- dummy tab
			if (!( 'right_space' in this )) {
				this.right_space = 0;
			}
			this.jqo_tab_dummy = $('<div>')
				.attr('class','ttt-tab-dummy')
				.css({
					'float':'left',
					width:this.right_space+'px',
					height:'10px'
				})
				.appendTo(this.jqo_tabs);

			//-- clear both
			this.jqo_tabs.append( $("<div style='clear:both;'></div>") );

			this.jqo_tabs.children('.ttt-tab')
				.click(function(e){
					_this.select($(this).data('tab-key'));
				})
				.mouseenter(function(e){
					$(this).addClass('ttt-tab-hover');
				})
				.mouseleave(function(e){
					$(this).removeClass('ttt-tab-hover');
				})

			this.jqo_tab_selector.change(function(){
				_this.select(
					$(this).find( "option:selected" )
						.data('tab-key')
				);
			});

			//-- container resize
			this.resize_handler = function() {
				_this.onContainerResized();
			};
			$(window).bind( "resize", this.resize_handler );
			this.draw();
		},

		activate : function(tab_key) {
			this.select(tab_key);
		}
	}

	tScope.CTTab = CTTab;

}(jQuery));
