/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CThumb = {};
	CThumb.prototype = {

		base : tScope.CObject,
		init: 'setup',

		getBoard : function() {
			return this.jqo.find('.tpv-board');
		},

		moveFocus : function(pos) {
			if ( pos == 'L' ) {
				var jqo = this.jqo.prev('.tpv-container');
				if ( jqo.length ) {
					jqo.focus();
				}
			}
			if ( pos == 'R' ) {
				var jqo = this.jqo.next('.tpv-container');
				if ( jqo.length ) {
					jqo.focus();
				}
			}
		},

		swapPosition : function(pos) {
			if ( pos == 'L' ) {
				var jqo = this.jqo.prev('.tpv-container');
				if ( jqo.length ) {
					this.jqo.after( jqo );
				}
			}
			if ( pos == 'R' ) {
				var jqo = this.jqo.next('.tpv-container');
				if ( jqo.length ) {
					this.jqo.before( jqo );
				}
			}
		},

		mouseEnter : function(){
			this.addbtn_right.jqo.show();
			this.addbtn_left.jqo.show();
		},

		mouseLeave : function(){
			this.addbtn_right.jqo.hide();
			this.addbtn_left.jqo.hide();
		},

		setPic : function( fkey ){
			tScope.CImgTool.loadImage( tScope.CPic.url_m( fkey ),
				this, function(img) {

				var size = this.imposeMaxSize(
					img.width,
					img.height,
					this.spec.content_width,
					this.spec.content_height
				);

				var margin_top = 0;
				if ( size.height < this.spec.content_height ) {
					margin_top = ( this.spec.content_height
						- size.height ) / 2;
				}

				var pic = $(img).clone();

				this.content
					.html('')
					.append( pic
						.css({
							'margin-top':margin_top+'px',
							width:size['width']+'px',
							height:size['height']+'px'
						})
					);
			});
		},

		setup : function(){

			var _this = this;

			this.spec = {};
			var spec = this.spec;
			spec.lng = tScope.loadLang("sshow.thumb");

			this.jqo = $('<div>')
				.attr('class','tpv-container')

			this.content = $('<div>')
				.attr('class','tpv-content');

			tScope.CSandBox.append( this.jqo, this, function(jqo){
				spec.container_width = parseInt(jqo.width());
				spec.container_height = parseInt(jqo.height());
				jqo.detach();
			});

			tScope.CSandBox.append( this.content, this, function(content){
				spec.content_outer_width = parseInt(content.outerWidth(true));
				spec.content_outer_height = parseInt(content.outerHeight(true));
				spec.content_width = parseInt(content.width());
				spec.content_height = parseInt(content.height());
			});

			this.content
				.css({
					position:"absolute",
					left:(spec.container_width-spec.content_outer_width)/2+'px',
					top:(spec.container_height-spec.content_outer_height)/2+'px'
				})
				.click(function(e){
					_this.onClick();
				});

			this.jqo
				.attr('tabindex',0)
				.data('tobj',this)
				.mouseenter(function(e){
					_this.mouseEnter(e);
				})
				.mouseleave(function(e){
					_this.mouseLeave(e);
				})
				.keyup(function(e){ 
					e.preventDefault();
					var code = e.which;
					if( code==32 ) {
						_this.onClick();
					} else if ( code==37 ) {//left
						_this.moveFocus('L');
					} else if ( code==39 ) {//right
						_this.moveFocus('R');
					}
				})
				.keydown(function(e){
					var code = e.which;
					if( code==32 ) {
						e.preventDefault();
					} else if ( code==37 ) {//left
						e.preventDefault();
					} else if ( code==39 ) {//right
						e.preventDefault();
					}
				})
				.append(
					$('<div>')
					.attr('class','tpv-board')
					.css({
					position:"absolute",
						width:spec.container_width+'px',
						height:spec.container_height+'px'
					})
					.append(this.content)
				);

			this.mulselt = tScope.create(tScope.CMulSel,{
				spec:this.spec
			})
			.appendTo(this)
			.show();

			this.spec.pos = 'B';
			this.addbtn_right = tScope.create(tScope.CAddBtnTab,{
				spec:this.spec,
				onClick:function(e,pos){
					_this.onAddNew(pos);
				}
			})
			.appendTo(this);

			this.spec.pos = 'A';
			this.addbtn_left = tScope.create(CAddBtnTab,{
				spec:this.spec,
				onClick:function(e,pos){
					_this.onAddNew(pos);
				}
			})
			.appendTo(this);

			this.delbtn = tScope.create(CDelBtn,{
				spec:this.spec,
				onClick:function(e){
					_this.onRemove();
				}
			})
			.appendTo(this)
			.show();

			this.delbtn.onClick = function(e){
				_this.onRemove();
			};

			this.move_handle = tScope.create(CMoveHandle,{
				spec:this.spec,
				onMove:function(dir){
					_this.swapPosition(dir);
				},
				onCaptureMouse:function(e){
					_this.onCaptureMouse(e);
				}
			})
			.appendTo(this)
			.show();
		},

		imposeMaxSize : function ( w_org, h_org, w_max, h_max ) {
			if (( w_org <= w_max ) && ( h_org <= h_max )) {
				w = w_org;
				h = h_org;
			} else if (( w_org > w_max ) && ( h_org > h_max )) {
				w = Math.round((h_max / h_org) * w_org);
				if ( w_max >= w ) {
					h = h_max;
				} else {
					w = w_max;
					h = Math.round((w_max / w_org) * h_org);
				}
			} else if ( w_org > w_max ) {
				w = w_max;
				h = Math.round((w_max / w_org) * h_org);
			} else {
				w = Math.round((h_max / h_org) * w_org);
				h = h_max;
			}

			return { width:w, height:h };
		}
	}

	tScope.CThumb = CThumb;

}(jQuery));
