/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CMulSel = {};
	CMulSel.prototype = {

		base : tScope.CObject,
		init: 'setup',

		setup : function() {
			var _this = this;
			var spec = this.spec;
			var title = spec.lng["title:mulsel"];

			this.jqo = $('<input>')
				.attr('class','tpv-mulsel')
				.attr('type','checkbox')
				.attr('title',title)
				.css({
					position:"absolute"
				})
				.hide();
		},

		appendTo : function( tobj ){
			this.jqo.appendTo(tobj.getBoard());
			return this;
		},
	
		show : function() {
			this.jqo.show();
			return this;
		}
	}

	tScope.CMulSel = CMulSel;

	CAddBtnTab = {};
	CAddBtnTab.prototype = {

		base : tScope.CObject,
		init: 'setup',

		setup : function() {

			var _this = this;
			var spec = this.spec;
			var title = spec.lng["title:addnew"];

			this.pos = spec.pos;
			spec.label = '✚';
			spec.tab_width = 18;
			spec.tab_height = 70;
			spec.tab_top = ( spec.container_height - spec.tab_height ) / 2;
			spec.rel_dist = spec.tab_width / 4;

			this.jqo = $('<div>')
				.attr('class','tpv-addnew')
				.attr('title',title)
				.css({
					position:"absolute"
				})
				.click( function( e ) {
					_this.onClick( e, _this.pos );
				})
				.hide()
				.mouseover(function(e){
					$(this).addClass('tpv-addnew-mo');
				})
				.mouseout(function(e){
					$(this).removeClass('tpv-addnew-mo');
				})
				.append( $( "<span>" )
					.css({
						position:"absolute"
					})
					.html(spec.label)
				);

			if ( this.pos == 'A' ) {
				this.jqo
					.css({
						width:spec.tab_width+"px",
						right:-spec.tab_width+"px",
						height:spec.tab_height+"px",
						"line-height":spec.tab_height+"px",
						top:spec.tab_top+"px",
						"border-radius":"0 6px 6px 0",
						"border-left-width":0
					})
					.find('span').css({
						right:spec.rel_dist+"px"
					});
			} else {
				this.jqo
					.css({
						width:spec.tab_width+"px",
						left:-spec.tab_width+"px",
						height:spec.tab_height+"px",
						"line-height":spec.tab_height+"px",
						top:spec.tab_top+"px",
						"border-radius":"6px 0 0 6px",
						"border-right-width":0
					})
					.find('span').css({
						left:spec.rel_dist+"px"
					});
			}
		},

		appendTo : function( tobj ){
			this.jqo.appendTo(tobj.getBoard());
			return this;
		}
	}

	tScope.CAddBtnTab = CAddBtnTab;

	CDelBtn = {};
	CDelBtn.prototype = {

		base : tScope.CObject,
		init: 'setup',

		setup : function() {

			var _this = this;
			var spec = this.spec;
			var title = spec.lng["title:delete"];

			this.jqo = $('<a>')
				.attr('class','tpv-delbtn')
				.attr('title',title)
				.attr('href','#')
				.css({
					position:"absolute",
					right:"4px",
					top:"4px"
				})
				.hide()
				.click( function( e ) {
					e.preventDefault();
					_this.onClick();
				})
				.keyup(function(e){ 
					e.preventDefault();
					e.stopImmediatePropagation();
					var code = e.which;
					if( code==32 ) {
						_this.onClick();
					}
				})
				.keydown(function(e){
					var code = e.which;
					if( code==32 ) {
						e.preventDefault();
					}
				})
				.html( tScope.CBrowser.isIE7() ? 'x' : '✕' );
		},

		appendTo : function( tobj ){
			this.jqo.appendTo(tobj.getBoard());
			return this;
		},
	
		show : function() {
			this.jqo.show();
			return this;
		}
	}

	tScope.CDelBtn = CDelBtn;

	CMoveHandle = {};
	CMoveHandle.prototype = {

		base : tScope.CObject,
		init: 'setup',

		setup : function() {

			var _this = this;
			var spec = this.spec;
			var title_left = spec.lng["title:move-left"];
			var title_right = spec.lng["title:move-right"];
			var title_center = spec.lng["title:move"];
			var margin_x = (spec.container_width-spec.content_width)/2
			var move_bar_width = spec.content_width - 20 * 2;

			this.jqo = $('<div>')
				.attr('class','tpv-move-container')
				.css({
					position:"absolute",
					"margin-left":margin_x+"px",
					"margin-right":margin_x+"px",
					width:spec.content_width+'px'
				})
				.hide()
				.append( $('<div>')
					.attr('class',
						'tpv-move-btn' + ' ' +
						'tpv-move-left')
					.attr('title',title_left)
					.attr('tabindex',0)
					.click( function( e ) {
						e.preventDefault();
						_this.onMove('L');
					})
					.keyup(function(e){ 
						e.preventDefault();
						e.stopImmediatePropagation();
						var code = e.which;
						if( code==32 ) {
							_this.onMove('L');
						}
					})
					.keydown(function(e){
						var code = e.which;
						if( code==32 ) {
							e.preventDefault();
						}
					})
					.html('◂')
				)
				.append( $('<div>')
					.attr('class',
						'tpv-move-btn' + ' ' +
						'tpv-move-right')
					.attr('title',title_right)
					.attr('tabindex',0)
					.click( function( e ) {
						e.preventDefault();
						_this.onMove('R');
					})
					.keyup(function(e){ 
						e.preventDefault();
						e.stopImmediatePropagation();
						var code = e.which;
						if( code==32 ) {
							_this.onMove('R');
						}
					})
					.keydown(function(e){
						var code = e.which;
						if( code==32 ) {
							e.preventDefault();
						}
					})
					.html('▸')
				)
				.append( $('<div>')
					.attr('class',
						'tpv-move-btn' + ' ' +
						'tpv-move-center')
					.attr('title',title_center)
					.mousedown( function( e ) {
						_this.onCaptureMouse(e);
					})
					.html('⇌')
				)
				.append('<div style="clear:both;"></div>');
		},

		appendTo : function( tobj ){
			this.jqo.appendTo(tobj.getBoard());
			return this;
		},
	
		show : function() {
			this.jqo.show();
			return this;
		}
	}

	tScope.CMoveHandle = CMoveHandle;

}(jQuery));
