/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	CViewSShow_slides = {};
	CViewSShow_slides.prototype = {

		base : tScope.CViewSShow,

		setup : function(){
			this.$setup();
			var tab_key = "slides";

			var _this = this;
			this.lng = tScope.loadLang('js.data-table');
			this.selected_thumb = null;

			//-- validator
			tScope.CValidator.setup();

			//-- picture property tab
			var lng_tab = tScope.loadLang("sshow.slides.tab");
			this.ppt_tab = tScope.create(tScope.CTTab,{
				jqo:$('#picture-tabs'),
				tabs:{
					'picture':{
						'tab-label':lng_tab['picture']
					},
					'link':{
						'tab-label':lng_tab['link']
					}
				},
				onSelect: function(tab_key) {
					if ( _this.selected_thumb ) {
						_this.selected_thumb.sitem.select(tab_key);
					}

					if ( tab_key == 'link' ) {
						_this.slide_link.effect_type.sshow.resume();
					}
				},
				onDeselect: function(tab_key) {
					if ( _this.selected_thumb ) {
						_this.selected_thumb.sitem.deselect(tab_key);
					}

					if ( tab_key == 'link' ) {
						_this.slide_link.effect_type.sshow.pause();
					}
				}
			});

			//-- slide link
			this.slide_link = tScope.create(tScope.CPn_slide_link,{
				prt:this
			});

			//-- view picture
			this.pic_view = tScope.create(tScope.CPn_pic_view,{
				jqo:$('#pn-pic-view')
			});

			//-- upload picture
			this.pic_upload = tScope.create(tScope.CPn_pic_upload,{
				jqo:$('#pn-pic-upload'),
				sshow_id:this.sshow_id
			});

			//-- scroll board
			this.thumb_board = tScope.create(tScope.CThumbBoard,{
				jqo_container:$('#tlv-container'),
				jqo_board:$('#tlv-board')
			});

			//-- delete button
			$('#tlv-delete').click(function(e){
				e.preventDefault();
				_this.deleteU();
			});

			//-- addnew button
			$('#tlv-addnew').click(function(e){
				e.preventDefault();
				_this.addNewU();
			});

			//-- save button
			$('#sshow-save').click(function(e){
				e.preventDefault();
				_this.saveU(tab_key,$(this));
			});

			//-- document
			this.doc
				.newSItem(function(sitem){
					var thumb = sitem.thumb;
					_this.setupThumb(thumb);
					_this.thumb_board.jqo_board.append( thumb.jqo );
					thumb.jqo.show();
				})
				.load("slides");

			//-- select a tab
			this.ppt_tab.activate("picture");
			this.spt_tab.activate(tab_key);

			//-- select first item
			var jqo = this.getJqoPanels().first();
			if ( jqo.length ) {
				var thumb = jqo.data('tobj');
				thumb.onClick();
			}

			//-- update
			this.update();
		},

		getJqoPanels : function() {
			return this.thumb_board.jqo_board.find('.tpv-container');
		},

		update : function() {
			this.thumb_board.adjustBoardSize();
			this.updatePPVContainer();
		},

		updatePPVContainer : function() {
			var ax = this.getJqoPanels();
			if ( ax.length ) {
				$('#tlv-container').show();
				$('#ppv-container').show();
			} else {
				$('#tlv-container').hide();
				$('#ppv-container').hide();
			}
		},

		captureMouse : function( e, jqo ){
			this.thumb_board.addMouseCapture( e, jqo );
		},

		selectThumb : function( thumb ) {
			//-- close tab
			if ( this.selected_thumb ) {
				this.selected_thumb.sitem.deselect(this.ppt_tab.getSelectedTabKey());
			}
			//-- switch tab
			this.selected_thumb = thumb;

			//-- make the thumb visible on the board
			var x1 = thumb.jqo.offset().left+150;
			var jqo = this.thumb_board.jqo_container;
			var x2 = jqo.width();
			var d = x1-x2;
			if ( d > 0 ) {
				jqo.scrollLeft(jqo.scrollLeft()+d);
			}

			//-- open tab
			this.selected_thumb.sitem.select(this.ppt_tab.getSelectedTabKey());

			//-- change visual
			this.getJqoPanels().removeClass('tpv-container-sel');
			this.getJqoPanels().find('.tpv-addnew').removeClass('tpv-container-sel');

			this.selected_thumb.jqo.addClass('tpv-container-sel');
			this.selected_thumb.addbtn_left.jqo.addClass('tpv-container-sel');
			this.selected_thumb.addbtn_right.jqo.addClass('tpv-container-sel');
		},

		setupThumb : function(thumb){
			var _this = this;

			thumb.onAddNew = function(pos){
				_this.addThumb(this,pos);
			};

			thumb.onRemove = function(){
				_this.removeThumb(this);
			};

			thumb.onClick = function(){
				_this.selectThumb(this);
			};

			thumb.onCaptureMouse = function(e){
				_this.captureMouse(e, this.jqo);
			};

			return thumb;
		},

		addThumb : function( ref, pos ) {

			var thumb = this.doc.createSItem().thumb;
			this.setupThumb(thumb);

			thumb.jqo.hide();

			if ( ref == null ) {
				var jqos = this.getJqoPanels();
				if ( jqos.length ) {
					if ( pos == 'A' ) {
						thumb.jqo.insertAfter(jqos.last());
					} else {
						thumb.jqo.insertBefore(jqos.first());
					}
				} else {
					thumb.jqo.appendTo(this.thumb_board.jqo_board);
				}
			} else {
				if ( pos == 'A' ) {
					thumb.jqo.insertAfter(ref.jqo);
				} else {
					thumb.jqo.insertBefore(ref.jqo);
				}
			}

			this.update();
			thumb.jqo.show('fast');
			this.selectThumb(thumb);
			return thumb;
		},

		removeThumb : function( thumb ) {
			var _this = this;
			var thumb_sel = null;
			if ( this.selected_thumb == thumb ) {
				var jqo = this.selected_thumb.jqo.next();
				if ( jqo.length ) {
					thumb_sel = jqo.data('tobj');
				} else {
					jqo = this.selected_thumb.jqo.prev();
					if ( jqo.length ) {
						thumb_sel = jqo.data('tobj');
					} else {
						this.selected_thumb = null;
					}
				}
			}

			thumb.jqo.remove();
			thumb.jqo.stop(true);
			thumb.jqo.hide('fast',function(){
				_this.update();
				if ( thumb_sel ) {
					_this.selectThumb(thumb_sel);
				}
			});
		},

		addNewU : function() {
			var thumb = this.addThumb( null, 'B' );
			this.thumb_board.scrollTo(thumb.jqo);
		},

		deleteU : function(){
			var cnt = this.thumb_board.getMSelCount();
			if ( cnt == 0 ) {
				alert( this.lng['select-at-least-one'] );
			} else {
				var msg = this.lng['confirm-delete'];
				msg = msg.replace( '#cnt#', cnt );

				if ( confirm ( msg ) ) {
					this.thumb_board.removeMSel();
				}
			}
		}

	}

	tScope.CViewSShow_slides = CViewSShow_slides;

}(jQuery));
