<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

include_once( 'CTemplate_crud.class.php' );

class CTemplate_sshow_crud_search extends CTemplate_crud {

	public function outputWebReso() {
		CJsReso::loadLang("js.data-table");
		CJsReso::loadLang("js.export");

		parent::outputWebReso();

		$url_tpl = $this->getTplFolderUrl();
		$_res = array();
		$_res[ 'CExportBtn' ] = 'js';
		echo CWebReso::render( "{$url_tpl}js/tscope/", $_res );
	}

	private function showThumbs($fs) {
		$dcx = json_decode($fs->val("dconf"),true);
		$idx = 0;
		$url_pic = CPic::url();
		$path_pic = CPic::path();
		$max = 10;
		$w_cell = 55;
		$h_cell = 55;
		$num = count($dcx['sitems']);
		foreach( $dcx['sitems'] as &$sitem ) {
			$fkey = $sitem['fkey'];
			$fn = CPic::fn_s($fkey);
			$path = $path_pic . $fn;
			if ( file_exists( $path ) ) {
				list($w_img, $h_img) = getimagesize($path);

				if ( $w_img >= $h_img ) {
					$h_img = round(( $w_cell / $w_img ) * $h_img );
					$w_img = $w_cell;
				} else {
					$w_img = round(( $h_cell / $h_img ) * $w_img );
					$h_img = $h_cell;
				}
				$margin_x = round(( $w_cell - $w_img ) / 2 );
				$margin_y = round(( $h_cell - $h_img ) / 2 );

				echo CHtmlTag::create( "div" )
					->set( "class", array("cell") )
					->set( "style", array(
						"width"=>"{$w_cell}px",
						"height"=>"{$h_cell}px",
					))
					->setInside(
						CHtmlTag::create( "img" )
							->set( "src", $url_pic . $fn )
							->set( "width", $w_img )
							->set( "height", $h_img )
							->set( "style", array(
								"margin"=>"{$margin_y}px {$margin_x}px",
								"border-radius"=>"3px",
							))
					)
					->render();

				$idx++;
			}

			if ( $idx == $max ) {
				if ( $idx < $num ) {
					echo "᛫᛫᛫";
				}
				break;
			}
		}
	}

	function output() {

		$sc = $this->prt->sc;
		$dt = $this->prt->dt;
		$fs = $this->prt->fs;
		$dt->setup( 1, 10, "sshow_id!DESC" );
		$this->setBreadcrumbs(array(
			$this->lng_bcrumbs[ "slideshows" ],
			$this->lng_crud[ "title:search" ],
		));

/////////////////////////////////////////////////////////////////
		$this->outputHtmlBegin();
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// [BEGIN] HTML
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////?>
<html>

<head>

<?php $this->outputHtmlHead(); ?>

<style>
.title {
	margin-bottom:6px;
	font-size:120%;
	color:#666;
	text-shadow:1px 1px 1px #ccc;
}
.cell {
	display:inline-block;
	*zoom:1;
	*display:inline;
	vertical-align:bottom;
	margin:3px 3px 0 0;
	border-radius:3px;
	background-color:#eee;
}
</style>

</head>

<body>

<div id="container">

<?php $this->outputBodyHeader(); ?>

<div id="content">

<?php $this->outputInfoBox(); ?>
<?php $this->outputErrorBox(); ?>

<?php if ( $this->prt->b_show_result ) { ?>

<?php $this->outputFormBegin(); ?>

<?php $this->outputSectionBegin( $this->lng_crud[ "search-criteria" ] ); ?>

	<div class='sc-container'>

		<?php
			$fx = array(
				"status",
				"title",
			);
		?>

		<?php foreach( $fx as $f ): ?>
		<div class='sc-box'>
			<div class='sc-label'>
				<?php echo $sc->get( "{$f}.label!html" ); ?>:
			</div>
			<?php echo $sc->get( $f ); ?> 
		</div>
		<?php endforeach; ?>

		<?php $this->outputSearchButton(); ?> 

		<div class='sc-clear'></div>

	</div>

	<div class='sc-clear'></div>

<?php $this->outputSectionEnd(); ?>

<?php $this->outputSectionBegin( $this->lng_crud[ "search-results" ] ); ?>

	<?php $this->outputDtTopBar(); ?>

	<div style='overflow:auto;'>
	<table class='dt-table'>

		<tr>
			<th nowrap='false'><?php $this->outputSortBtns( 'sshow_id' ); ?> 
				<?php echo $fs->get( 'sshow_id.label' ); ?></th>
			<th><?php $this->outputSelRecHeader(); ?></th>
			<th nowrap='false'><?php $this->outputSortBtns( 'status' ); ?> 
				<?php echo $fs->get( 'status.label' ); ?></th>
			<th><?php $this->outputEditBtnHeader(); ?></th>
			<th nowrap='false'><?php $this->outputSortBtns( 'title' ); ?> 
				<?php echo $fs->get( 'title.label' ); ?></th>
		</tr>

		<?php while( $dt->getData( $fs ) ) { ?><tr>
			<td style='text-align:right;'><?php echo $pkv = $fs->get( 'sshow_id' ); ?></td>
			<td style='text-align:center;'><?php $this->outputSelRecVal( $pkv ); ?></td>
			<td style='text-align:center;'><?php echo $fs->get( 'status' ); ?></td>
			<td style='text-align:left;'><?php $this->outputEditBtnVal( $pkv ); ?></td>
			<td style='text-align:left;'><div class='title'><?php echo $fs->get( 'title' ); ?></div>
				<?php $this->showThumbs($fs); ?></td>
		</tr><?php } ?>

	</table>
	</div>

	<?php $this->outputDtBottomBar(); ?>

<?php $this->outputSectionEnd(); ?>

<?php $this->outputFormEnd(); ?>

<?php } //-- b_show_result ?>

<?php $this->outputBodyFooter(); ?>

</div><!-- content -->

</div><!-- container -->

</body>
</html>
<?php ///////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// [END] HTML
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
		$this->outputHtmlEnd();
	}
}

?>