<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CTemplate_sys extends CTemplate {

	//----------------------------------------------------------------
	// setup
	//----------------------------------------------------------------
	public function setup() {
		parent::setup();
		CEnv::loadLang( "app.info", $this->lng_app );
		CEnv::loadLang( "app.status-bar", $this->lng_sbar );
		CEnv::loadLang( "app.bcrumbs", $this->lng_bcrumbs );
	}

	//----------------------------------------------------------------
	// Helper Functions
	//----------------------------------------------------------------
	public function getTplFolderUrl() {
		return $this->prt->getFolderUrl() . "tpls/";
	}

	public function getSysTplFolderUrl() {
		return $this->prt->sys->getFolderUrl() . "sys/tpls/";
	}

	public function getUsername() {
		return htmlspecialchars( CUSess::get( 'username' ) );
	}

	public function getUserInfo() {
		$sx = array();

		$sx[] = $this->lng_sbar[ "username" ] . " : " .
			htmlspecialchars( CUSess::get( 'username' ) );

		//$s = $this->lng_sbar[ "timeout" ];
		//$s = str_replace( "#remaining#", CUSess::getTimeoutStr(), $s );
		//$s = str_replace( "#expire#", date("Y-m-d H:i:s", CUSess::get( '?' ) ), $s );
		//$sx[] = $s;

		if ( CRoles::hasPms("user-info") ) {
			$sx[] = "Roles : " . CRoles::printRoles();
			$sx[] = "Pms : " . CRoles::printPms();
		}
		return implode("\r\n", $sx);
	}

	//----------------------------------------------------------------
	// Breadcrumbs
	//----------------------------------------------------------------
	public function setBreadcrumbs( $breadcrumbs ) {
		$this->breadcrumbs = $breadcrumbs;
	}

	public function getBreadcrumbs() {
		$s = implode( $this->lng_sbar[ "arrow" ], $this->breadcrumbs );
		return htmlspecialchars( $s );
	}

	//----------------------------------------------------------------
	// InfoBox
	//----------------------------------------------------------------
	public function outputInfoBox() {
		$emx = CUInfo::get( "info:*" );
		if ( count( $emx )  ) {
			foreach( $emx as &$em ) {
				$em = htmlspecialchars( $em );
			}
			$msg = implode( "<br/>", $emx );
?>
<div class='info-box'>
<?php echo $msg; ?>
</div>
<?php
		}
	}

	//----------------------------------------------------------------
	// ErrorBox
	//----------------------------------------------------------------
	public function outputErrorBox() {
		$emx = CUInfo::get( "error:*" );
		if ( count( $emx )  ) {
			foreach( $emx as &$em ) {
				$em = htmlspecialchars( $em );
			}
			$msg = implode( "<br/>", $emx );
?>
<div class='error-box'>
<table width='99%' style='border-collapse: collapse;'>
<tr>
	<td align='center' valign='middle' width='20'><img src='<?php echo $this->getSysTplFolderUrl(); ?>img/icon-warn.gif'></td>
	<td width='10'>&nbsp;</td>
	<td align='left' valign='middle'><?php echo $msg; ?></td>
</tr>
</table>
</div>
<?php
		}
	}

	//----------------------------------------------------------------
	// WebReso
	//----------------------------------------------------------------
	public function outputWebReso() {
		CJsReso::loadLang("js.tool-tip");
		CJsReso::output();

		$sys_tpl = $this->getSysTplFolderUrl();

		$_res = array();
		$_res[ 'style' ] = 'css';
		echo CWebReso::render( "{$sys_tpl}css/", $_res );

		$_res = array();
		$_res[ 'jquery' ] = 'js';
		echo CWebReso::render( "{$sys_tpl}js/jquery/", $_res );

		$_res = array();
		$_res[ 'tScope' ] = 'js';
		$_res[ 'CObject' ] = 'js';
		$_res[ 'CWaitIcon' ] = array('css','js');
		$_res[ 'CFormMain' ] = 'js';
		$_res[ 'CDataTable' ] = 'js';
		$_res[ 'CSandBox' ] = 'js';
		$_res[ 'CMenuSys' ] = 'js';
		$_res[ 'CCookie' ] = 'js';
		$_res[ 'CBalloon' ] = 'js';
		$_res[ 'CToolTip' ] = 'js';
		echo CWebReso::render( "{$sys_tpl}js/tscope/", $_res );
	}

	//----------------------------------------------------------------
	// HtmlHead
	//----------------------------------------------------------------
	public function outputHtmlHead() { ?>

<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title><?php echo $this->getBreadcrumbs(); ?></title>

	<?php
		$this->outputWebReso();
	}

	//----------------------------------------------------------------
	// FormBegin
	//----------------------------------------------------------------
	public function outputFormBegin() { ?>
<form class='form-main' action='<?php echo CEnv::getCurrentPageUrl(); ?>' method='post'>
<?php echo CState::output(); ?>
<input type='hidden' name='_cmd_path' value='<?php
		echo $this->sys->getCurrentEvent()->getCmdPath(); ?>' />
	<?php }

	//----------------------------------------------------------------
	// FormEnd
	//----------------------------------------------------------------
	public function outputFormEnd() { ?>
</form>
	<?php }

	//----------------------------------------------------------------
	// BackButton
	//----------------------------------------------------------------
	public function outputBackButton() { ?>
<div class='backbtn-container'>

	<button class='btn-std btn-event' cmd='search_ret' accesskey='b' 
		title="<?php echo $this->lng_crud[ 'title:back' ]; ?>"
	><?php echo $this->lng_crud[ 'label:back' ]; ?></button>

</div>
	<?php }

	//----------------------------------------------------------------
	// BodyHeader
	//----------------------------------------------------------------
	public function outputBodyHeader() { ?>
<div id="header">

<div id='main-menu'>
	<?php CMenu::output(); ?>
</div><!-- main-menu -->

<div class='staus-bar'>
	<div class="breadcrumb">
		<?php echo $this->getBreadcrumbs(); ?>
	</div>
	<div class="login-user">
		<span class="login-user-label"><?php echo $this->lng_sbar[ "user" ]; ?> : </span>
		<span class="login-user-name" title='<?php echo $this->getUserInfo(); ?>'>
			<?php echo $this->getUsername(); ?></span>
	</div>
	<div class="status-bar-clear"></div>
</div>

</div><!-- header -->

	<?php }

	//----------------------------------------------------------------
	// BodyFooter
	//----------------------------------------------------------------
	public function outputBodyFooter() { ?>
<div id="footer">

<!--<a class='site-link' href='' target='_blank'></a>-->

</div><!-- footer -->
	<?php }

	//----------------------------------------------------------------
	// SectionBegin
	//----------------------------------------------------------------
	public function outputSectionBegin( $legend = null ) { $this->legend = $legend; ?>
<fieldset class='section'>
<?php if ( !is_null( $legend ) ): ?>
<legend class='section-name'><?php echo $legend; ?></legend>
<?php endif; ?>
<div class='section-contents'>
	<?php }

	//----------------------------------------------------------------
	// SectionEnd
	//----------------------------------------------------------------
	public function outputSectionEnd() { ?>
</div><!-- section-contents -->
</fieldset>
	<?php }

}

?>