<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CTemplate_syscrud extends CTemplate_sys {

	//----------------------------------------------------------------
	// setup
	//----------------------------------------------------------------
	public function setup() {
		parent::setup();
		CEnv::loadLang( "crud", $this->lng_crud );
	}

	//----------------------------------------------------------------
	// SearchButton
	//----------------------------------------------------------------
	public function outputSearchButton() { $dt = $this->prt->dt; ?>
		<div class='sc-box'>
			<div class='sc-label'>
				&nbsp;
			</div>
			<button class='btn-std btn-event'
				cmd='search_pb?_dt:pi=1' accesskey='s'
				title="<?php echo $this->lng_crud[ "title:search" ]; ?>"
				><?php echo $this->lng_crud[ "label:search" ]; ?></button>
		</div>
	<?php }

	//----------------------------------------------------------------
	// DtTopBar
	//----------------------------------------------------------------
	public function outputDtTopBar( $ops = null ) {

		$dt = $this->prt->dt;

		//-- stats
		list( $sidx, $eidx, $total ) = $dt->getStats();
		if ( $total == 0 ) {
			$this->stats = $this->lng_crud[ "no-records" ];
		} else {
			$s = str_replace( "#class#", "dt-stat-val", $this->lng_crud[ "stats-line" ] );
			$s = str_replace( "#sidx#", $sidx, $s );
			$s = str_replace( "#eidx#", $eidx, $s );
			$s = str_replace( "#total#", $total, $s );
			$this->stats = $s;
		}

		//-- page tabs
		$this->page_tabs = '';
		$total = $dt->getPageTotal();
		if ( $total > 1 ) {
			$idx = $dt->getPageIndex();
			$w = 3;
			$tpl = array(
				"link"=>"<a href='' class='page-tab btn-event' " .
					"cmd='search_pb?_dt:pi=#page-no#' title='#title#'>#label#</a>",
				"sel"=>"<a href='' class='page-tab-sel btn-event' " .
					"cmd='search_pb?_dt:pi=#page-no#' title='#title#'>#label#</a>",
				"title-first"=>$this->lng_crud[ "title:first" ],
				"title-prev"=>$this->lng_crud[ "title:prev" ],
				"title-next"=>$this->lng_crud[ "title:next" ],
				"title-last"=>$this->lng_crud[ "title:last" ],
				"title-page"=>$this->lng_crud[ "title:page" ],
				"separator"=>$this->lng_crud[ "separator" ],
				"etc"=>$this->lng_crud[ "etc" ],
			);
			$this->page_tabs = CPageTab::getPageTabs( $total, $idx, $w, $tpl );
		}

		if ( $ops != 'none' ) {
	?>
	<div class='dt-top-bar'>
		<div class='dt-tool-box'>
			<?php $this->outputDtTopBarButtons( $ops ); ?>
		</div>
		<div class='dt-page-tab-box'>
			<?php echo $this->page_tabs; ?>
		</div>
		<div class='dt-clear'></div>
	</div>
	<?php
		}
	}

	//----------------------------------------------------------------
	// DtTopBarButtons
	//----------------------------------------------------------------
	public function outputDtTopBarButtons( $ops ) { ?>
			<button class='btn-std btn-event' cmd='search_pxy;reg_init' accesskey='n'
				title="<?php echo $this->lng_crud[ "title:addnew" ]; ?>"
				><?php echo $this->lng_crud[ "label:addnew" ]; ?></button>
			<button class='btn-std btn-del-multi'
				title="<?php echo $this->lng_crud[ "title:delete" ]; ?>"
				><?php echo $this->lng_crud[ "label:delete" ]; ?></button>
	<?php }

	//----------------------------------------------------------------
	// DtBottomBar
	//----------------------------------------------------------------
	public function outputDtBottomBar( $ops = null ) { ?>
	<div class='dt-bottom-bar'>
		<div class='dt-stat-box'>
			<?php echo $this->stats; ?>
		</div>
		<div class='dt-page-tab-box'>
			<?php echo $this->page_tabs; ?>
		</div>
		<div class='dt-clear'></div>
	</div>
	<?php }

	//----------------------------------------------------------------
	// SelRecHeader
	//----------------------------------------------------------------
	public function outputSelRecHeader() {
		$dt = $this->prt->dt;
	?>
<input type='checkbox' class='selrec-main' title='<?php
	echo $this->lng_crud[ "title:selrec-main" ]; ?>' />
	<?php }

	//----------------------------------------------------------------
	// SelRecVal
	//----------------------------------------------------------------
	public function outputSelRecVal( $pkv ) {
		$dt = $this->prt->dt;
	?>
<input type="checkbox" class="selrec-cb" name="_selrec_[]" value="<?php
		echo $pkv; ?>" title="<?php echo $this->lng_crud[ "title:selrec-cb" ]; ?>" />
	<?php }

	//----------------------------------------------------------------
	// EditBtnHeader
	//----------------------------------------------------------------
	public function outputEditBtnHeader() {
		$dt = $this->prt->dt;
	?>
<?php echo $this->lng_crud[ "icon:edit" ]; ?>
	<?php }

	//----------------------------------------------------------------
	// EditBtnVal
	//----------------------------------------------------------------
	public function outputEditBtnVal( $pkv ) {
		$dt = $this->prt->dt;
		$fs = $this->prt->fs;
		$pk = $fs->table->getPrimaryKey();
	?>
<a href='' class='btn-edit btn-event' cmd='search_pxy;edit_init?_key:<?php
		echo $pk . '=' . $pkv; ?>' title='<?php echo $this->lng_crud[ "title:edit" ]; ?>'
		><?php echo $this->lng_crud[ "icon:edit" ]; ?></a>
	<?php }

	//----------------------------------------------------------------
	// SortBtns
	//----------------------------------------------------------------
	public function outputSortBtns( $fname ) {

		$dt = $this->prt->dt;
		list( $asc, $desc ) = $dt->sortBtn( $fname );

		$s = "";
		$c = $asc ? "▲" : "△";

		$s .= "<a class='dt-sort-btn btn-event' ";
		$s .= "cmd='search_pb?_dt:pi=1&_dt:ob={$fname}!ASC' ";
		$s .= "href='' title='" . $this->lng_crud[ "title:asc" ] . "'>{$c}</a>";

		$c = $desc ? "▼" : "▽";

		$s .= "<a class='dt-sort-btn btn-event' ";
		$s .= "cmd='search_pb?_dt:pi=1&_dt:ob={$fname}!DESC' ";
		$s .= "href='' title='" . $this->lng_crud[ "title:desc" ] . "'>{$c}</a>";

		$s = "<span class='dt-sort-btns'>{$s}</span>";

		echo $s;
	}

}

?>