/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	var CBalloon = {
		jqo:null,

		getViewport : function() {
			var win = $(window);
			return {
				'x':win.scrollLeft(),
				'y':win.scrollTop(),
				'w':win.width(),
				'h':win.height()
			};
		},

		calcPos : function( jqo_ref, pos ) {

			var cord = jqo_ref.offset();
			var ref_top = cord.top;
			var ref_left = cord.left;
			var ref_width = jqo_ref.outerWidth();
			var ref_height = jqo_ref.outerHeight();

			var view = this.getViewport();
			if ( pos == 'top-bottom' ) {
				if (( ref_top-view.y ) >= (( view.y+view.h ) - ( ref_top+ref_height ))) {
					pos = 'top';
				} else {
					pos = 'bottom';
				}
			} else if ( pos == 'left-right' ) {
				if (( ref_left-view.x ) >= (( view.x+view.w ) - ( ref_left+ref_width ))) {
					pos = 'left';
				} else {
					pos = 'right';
				}
			} else if ( pos == '*' ){
				var d = ( ref_top-view.y );
				pos = 'top';

				var t = (( view.y+view.h ) - ( ref_top+ref_height ));
				if ( d < t ) {
					d = t;
					pos = 'bottom';
				}

				var t = ( ref_left-view.x );
				if ( d < t ) {
					d = t;
					pos = 'left';
				}

				var t = (( view.x+view.w ) - ( ref_left+ref_width ));
				if ( d < t ) {
					d = t;
					pos = 'right';
				}
			}

			return pos;
		},

		adjustTipX : function(view_x, view_w, cnt_left, cnt_width, tip_left, tip_min_x) {
			var dx = view_x - cnt_left;
			if ( dx > 0 ) {
				if ( dx > ( tip_left - tip_min_x ) ){
					dx = ( tip_left - tip_min_x );
				}
				tip_left -= dx;
				cnt_left += dx;
			}
			dx = (cnt_left+cnt_width) - (view_x+view_w);
			if ( dx > 0 ) {
				if ( dx > ( tip_left - tip_min_x ) ){
					dx = ( tip_left - tip_min_x );
				}
				tip_left += dx;
				cnt_left -= dx;
			}
			return { tip_left:tip_left, cnt_left:cnt_left };
		},

		adjustTipY : function(view_y, view_h, cnt_top, cnt_height, tip_top, tip_min_y) {
			var dy = view_y - cnt_top;
			if ( dy > 0 ) {
				if ( dy > ( tip_top - tip_min_y ) ){
					dy = ( tip_top - tip_min_y );
				}
				tip_top -= dy;
				cnt_top += dy;
			}
			dy = (cnt_top+cnt_height) - (view_y+view_h);
			if ( dy > 0 ) {
				if ( dy > ( tip_top - tip_min_y ) ){
					dy = ( tip_top - tip_min_y );
				}
				tip_top += dy;
				cnt_top -= dy;
			}
			return { tip_top:tip_top, cnt_top:cnt_top };
		},

		open : function( jqo_content, jqo_ref, pos ) {

			var ms = 300;
			var mm = 30;
			var ad_x = 5;
			var ad_y = 5;
			var tip_len = 10;
			var tip_mouth = 10;
			var tip_dist = 5;
			var tip_min_x = tip_mouth + 10;
			var tip_min_y = tip_mouth + 10;

			//-- reset balloon
			this.resetBalloon();

			//-- calc balloon pos
			pos = this.calcPos( jqo_ref, pos );

			//-- get content dimention
			var ctt_width;
			var ctt_height;
			tScope.CSandBox.append( jqo_content, this, function(ctt){
				ctt_width = ctt.outerWidth(true);
				ctt_height = ctt.outerHeight(true);
			});

			//-- create balloon
			var balloon = $('<div>')
				.attr('class',this.prefix + '-balloon')
				.css({
					position: "relative",
					width:ctt_width+"px",
					height:ctt_height+"px"
				})
				.append( jqo_content );

			var bal_width;
			var bal_height;
			tScope.CSandBox.append( balloon, this, function(bal){
				bal_width = bal.outerWidth(true);
				bal_height = bal.outerHeight(true);
				background_color = bal.css('background-color');
				border_color = bal.css('border-color');
			});

			//-- create tip & tip-shadow
			var tip = $('<div>')
					.css({//tip
						position: "absolute",
						"border-style": "solid",
						"width": 0,
						"font-size": 0,
						"line-height": 0
					});

			var tip_shadow = $('<div>')
					.css({//tip-shadow
						position: "absolute",
						"border-style": "solid",
						"width": 0,
						"font-size": 0,
						"line-height": 0
					});

			var cord = jqo_ref.offset();
			var ref_top = cord.top;
			var ref_left = cord.left;
			var ref_width = jqo_ref.outerWidth();
			var ref_height = jqo_ref.outerHeight();
			var view = this.getViewport();

			var cnt_top;
			var cnt_left;
			var cnt_width;
			var cnt_height;
			var tip_left;
			var tip_top;
			var mx;
			var my;

			switch( pos ){

			case 'bottom':
				var y = ref_top + ref_height;
				var x = ref_left + ref_width/2;
				cnt_top = y + tip_dist;
				cnt_left = x - parseInt(bal_width / 2);
				cnt_height = bal_height + tip_len;
				cnt_width = bal_width;
				tip_left = parseInt(( bal_width - tip_mouth ) / 2 );

				var rx = this.adjustTipX(
					view.x,
					view.w,
					cnt_left,
					cnt_width,
					tip_left,
					tip_min_x);
				cnt_left = rx.cnt_left;
				tip_left = rx.tip_left;

				cnt_left-= ad_x;
				mx = 0;
				my = mm;

				balloon.css({
					top:tip_len
				});
				tip.css({
					top:"-" + ( tip_len * 2 ) + "px",
					left:tip_left+"px",
					"border-width": tip_len + "px " + tip_mouth + "px"
				});
				tip_shadow.css({
					top:"-" + ( tip_len * 2 + 1 ) + "px",
					left:tip_left+"px",
					"border-width": tip_len + "px " + tip_mouth + "px"
				});
				tip.css({"border-color":
					"transparent " +
					"transparent " + 
					background_color + " " +
					"transparent"
				});
				tip_shadow.css({"border-color":
					"transparent " +
					"transparent " +
					border_color + " " +
					"transparent"
				});
				break;

			case 'top':
				var y = ref_top;
				var x = ref_left + ref_width/2;
				cnt_top = y - ( tip_dist + tip_len + bal_height );
				cnt_left = x - parseInt( bal_width / 2 );
				cnt_height = bal_height + tip_len;
				cnt_width = bal_width;
				tip_left = ( bal_width - tip_mouth ) / 2;

				var rx = this.adjustTipX(
					view.x,
					view.w,
					cnt_left,
					cnt_width,
					tip_left,
					tip_min_x);
				cnt_left = rx.cnt_left;
				tip_left = rx.tip_left;

				cnt_left-= ad_x;
				mx = 0;
				my = -mm;

				balloon.css({
					top:0
				});
				tip.css({
					bottom:"-" + ( tip_len * 2 ) + "px",
					left:tip_left+"px",
					"border-width": tip_len + "px " + tip_mouth + "px"
				});
				tip_shadow.css({
					bottom:"-" + ( tip_len * 2 + 1 ) + "px",
					left:tip_left+"px",
					"border-width": tip_len + "px " + tip_mouth + "px"
				});
				tip.css({"border-color":
					background_color + " " +
					"transparent " +
					"transparent " + 
					"transparent"
				});
				tip_shadow.css({"border-color":
					border_color + " " +
					"transparent " +
					"transparent " +
					"transparent"
				});
				break;

			case 'right':
				var y = ref_top + ref_height/2;
				var x = ref_left + ref_width;
				cnt_top = y - parseInt( bal_height / 2 );
				cnt_left = x + tip_dist;
				cnt_height = bal_height;
				cnt_width = bal_width + tip_len;
				tip_top = parseInt(( bal_height - tip_mouth ) / 2 );

				var rx = this.adjustTipY(
					view.y,
					view.h,
					cnt_top,
					cnt_height,
					tip_top,
					tip_min_y);
				cnt_top = rx.cnt_top;
				tip_top = rx.tip_top;

				cnt_top -= ad_y;
				mx = mm;
				my = 0;

				balloon.css({
					left:tip_len
				});
				tip.css({
					left:"-" + ( tip_len * 2 ) + "px",
					top:tip_top+"px",
					"border-width": tip_mouth + "px " + tip_len + "px"
				});
				tip_shadow.css({
					left:"-" + ( tip_len * 2 + 1 ) + "px",
					top:tip_top+"px",
					"border-width": tip_mouth + "px " + tip_len + "px"
				});
				tip.css({"border-color":
					"transparent " +
					background_color + " " +
					"transparent " +
					"transparent"
				});
				tip_shadow.css({"border-color":
					"transparent " +
					border_color + " " +
					"transparent " +
					"transparent"
				});
				break;

			case 'left':
				var y = ref_top + ref_height/2;
				var x = ref_left;
				cnt_top = y - parseInt( bal_height / 2 );
				cnt_left = x - ( tip_dist + tip_len + bal_width );
				cnt_height = bal_height;
				cnt_width = bal_width + tip_len;
				tip_top = parseInt(( bal_height - tip_mouth ) / 2 );

				var rx = this.adjustTipY(
					view.y,
					view.h,
					cnt_top,
					cnt_height,
					tip_top,
					tip_min_y);
				cnt_top = rx.cnt_top;
				tip_top = rx.tip_top;

				cnt_top -= ad_y;
				mx = -mm;
				my = 0;

				balloon.css({
					left:0
				});
				tip.css({
					right:"-" + ( tip_len * 2 ) + "px",
					top:tip_top+"px",
					"border-width": tip_mouth + "px " + tip_len + "px"
				});
				tip_shadow.css({
					right:"-" + ( tip_len * 2 + 1 ) + "px",
					top:tip_top+"px",
					"border-width": tip_mouth + "px " + tip_len + "px"
				});
				tip.css({"border-color":
					"transparent " +
					"transparent " +
					"transparent " +
					background_color
				});
				tip_shadow.css({"border-color":
					"transparent " +
					"transparent " +
					"transparent " + 
					border_color
				});
				break;
			}

			//-- append tip & tip-shadow to balloon
			balloon
				.append( tip_shadow )
				.append( tip );

			//-- create balloon container
			this.jqo = $('<div>')
				.css({
					overflow:"hidden",
					position: "absolute",
					top:cnt_top+my+"px",
					left:cnt_left+mx+"px",
					width:cnt_width+"px",
					height:cnt_height+"px",
					opacity:0,
					"z-index":100
				})
				.append( balloon )
				.appendTo('body')
				.animate({
					top:cnt_top+"px",
					left:cnt_left+"px",
					opacity:0.95
				},ms);
		},

		close : function() {
			if ( this.jqo ) {
				var _this = this;
				this.jqo.fadeOut(300,function(){
					_this.jqo.remove();
					_this.jqo = null;
				});
			}
		},

		resetBalloon : function() {
			if ( this.jqo ){
				this.jqo.stop(true,true);
				if ( this.jqo ){
					this.jqo.remove();
					this.jqo = null;
				}
			}
		},

		setup : function( prefix ) {
			this.prefix = prefix;
			var _this = this;
			$( '.' + prefix ).each( function(){
				var content = $(this).next( '.' + prefix + '-content' );
				$(this).click(function(){
					if ( _this.jqo ) {
						_this.close();
					} else {
						_this.open(content,$(this),'top-bottom');
					}
				}).mouseleave(function(){
					_this.close();
				});
			});
		}
	};

	tScope.CBalloon = CBalloon;

}(jQuery));
