/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/
(function($){

	tScope.vmenu_pos_func = function (tobj){

		var jqo_ref = tobj.prt.jqo;
		var xy_ref = jqo_ref.offset();

		var top_ref = xy_ref.top;
		var left_ref = xy_ref.left;

		var w_ref = jqo_ref.outerWidth();
		var h_ref = jqo_ref.outerHeight();

		var jqo_menu = tobj.jqo;
		var w_menu;
		var h_menu;
		tScope.CSandBox.append(jqo_menu,this,function(jqo){
			w_menu = jqo_menu.outerWidth();
			h_menu = jqo_menu.outerHeight();
		});
		var top_menu = top_ref + h_ref;
		var left_menu = left_ref;

		jqo_menu.css({
			"top":top_menu+"px",
			"left":left_menu+"px"
		});
	}

	function CMenu(prop) {
		this.menusys = prop.menusys;
		this.prt = prop.prt;
		this.jqo = prop.jqo;
		this.spec = prop.spec;
		this.zindex = prop.zindex;
		this.setup();
	}

	CMenu.prototype = {

		getTClass : function() {
			return this.menusys.getTClass( this );
		},

		getProp : function( prop ) {
			return this.menusys.getProp( prop, this );
		},

		setup : function() {
			var _this = this;
			this.items = [];

			var tclass = this.getTClass()
			this.jqo = $(tclass.html_tag)
				.attr('class',tclass.css_class)
				.css({
					"z-index":this.zindex
				});

			if ( 'attrs' in tclass ) {
				for( attr in tclass.attrs ) {
					this.jqo.attr(attr,tclass.attrs[attr]);
				}
			}

			var pos_func = tclass.pos_func;
			if ( pos_func != null ) {
				tScope[pos_func](this);
			}
			this.jqo.appendTo('body');
			
			var items = this.spec.items;
			for( var i=0; i<items.length; i++ ){
				var item = new CMenuItem({
					menusys:this.menusys,
					prt:this,
					jqo:null,
					spec:items[i],
					zindex:this.zindex
				});
				this.items.push(item);
				this.jqo.append(item.jqo);
			}
		},

		closeOtherChild : function(tobj){
			for( var i=0; i<this.items.length; i++ ){
				var item = this.items[i];
				if ( item != tobj ){
					if ( item.close() ) {
						return true;
					}
				}
			}
			if ( this.prt ) {
				return this.prt.closeOtherChild();
			}
			return false;
		},

		close : function(tobj){
			for( var i=0; i<this.items.length; i++ ){
				this.items[i].close();
			}
			if ( this.prt ) {
				this.jqo.remove();
			}
		}
	}

	function CMenuItem(prop) {
		this.menusys = prop.menusys;
		this.prt = prop.prt;
		this.jqo = prop.jqo;
		this.spec = prop.spec;
		this.zindex = prop.zindex;
		this.setup();
	}

	CMenuItem.prototype = {

		getTClass : function() {
			return this.menusys.getTClass( this );
		},

		getProp : function( prop ) {
			return this.menusys.getProp( prop, this );
		},

		setup : function() {
			var _this = this;
			this.menu = null;

			if ( this.jqo == null ) {
				var tclass = this.getTClass()
				this.jqo = $(tclass.html_tag)
					.attr('class',tclass.css_class)
					.html(this.spec.label);

				if ( 'attrs' in tclass ) {
					for( attr in tclass.attrs ) {
						this.jqo.attr(attr,tclass.attrs[attr]);
					}
				}

				if (( this.jqo.prop("tagName") == 'A' ) &&
					( 'href' in this.spec )) {
					var ch = this.spec.href.substring(0,1);
					if (( ch == '?' ) || ( ch == '#' )) {
						var href = window.location.href + this.spec.href;
					} else {
						var href = this.spec.href;
					}
					this.jqo.attr('href',href);
				}
			}

			this.jqo
				.click(function(e){
					_this.click(e);
				})
				.mouseenter(function(e){
					_this.mouseenter(e);
				});
		},

		closeOtherChild : function(){
			if ( this.prt != null ) {
				return this.prt.closeOtherChild(this);
			}
			return false;
		},

		open : function(e) {
			if ( this.menu == null ) {
				this.menu = new CMenu({
					menusys:this.menusys,
					prt:this,
					jqo:null,
					spec:this.spec.menu,
					zindex:this.zindex+1
				})
			}
		},

		close : function(){
			if ( this.menu != null ) {
				this.menu.close();
				this.menu = null;
				return true;
			}
			return false;
		},

		click : function(e) {

			//-- open/close submenu
			if ( 'menu' in this.spec ) {
				e.preventDefault();
				e.stopPropagation();
				if ( this.menu == null ) {
					this.open();
				} else {
					this.close();
				}
				return;
			}

			//-- hyper link
			if ( "href" in this.spec ) {
				return;
			}

			//-- javascript
			if ( "js" in this.spec ) {
				e.preventDefault();
				e.stopPropagation();
			}

			//-- alert
			if ( "alert" in this.spec ) {
				e.preventDefault();
				e.stopPropagation();
				alert(this.spec.alert);
			}

			//-- close menu
			this.menusys.close();
		},

		mouseenter : function(e) {
			var b = this.closeOtherChild();

			//-- no hover action on the root menu item
			if ( this.prt == null ) { return; }
			if ( !b ) { return; }

			//-- open menu when available
			if ( 'menu' in this.spec ) {
				this.open();
			}
		}
	}

	function CMenuSys(prop) {
		this.activation = prop.activation;
		this.selector = prop.selector;
		this.spec = prop.spec;
		this.setup();
	}

	CMenuSys.prototype = {

		getTClass : function( tobj ) {
			if (!( tobj.spec.tclass in this.spec.tclasses )) {
				console.log("Unknown tclass " +
					"[" + tobj.spec.tclass + "]" );
				return null;
			}
			return this.spec.tclasses[tobj.spec.tclass];
		},

		getProp : function( prop, tobj ) {
			var tclass = this.getTClass(tobj);

			if (!( prop in tclass )) {
				console.log( "Unknown prop " +
					"[" + tobj.tclass + "] " +
					"[" + tclass + "]" );
			}

			return tclass[prop];
		},

		setup : function() {
			var _this = this;

			//-- activation
			switch( this.activation ) {
			case "selector":
				this.root_item = new CMenuItem({
					menusys:this,
					prt:null,
					jqo:$(this.selector),
					spec:this.spec,
					zindex:this.spec.zindex
				});
				break;
			case 'auto':
				this.root_item = new CMenu({
					menusys:this,
					prt:null,
					jqo:null,
					spec:this.spec.menu,
					zindex:this.spec.zindex
				});
				this.root_item.jqo.appendTo($(this.selector));
				break;
			}

			//-- close menu when clicked outside
			$(document).click(function(e){
				_this.close();
			});
		},

		close : function(){
			this.root_item.close();
		}
	}

	tScope.CMenuSys = CMenuSys;

}(jQuery));
