/*js
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<
*/

/*-- Object.create function for older browser --*/
if (typeof Object.create !== "function") {
	Object.create = function(X) {
		function F(){}
		F.prototype = X;
		return new F();
	};
}

var tScope = {

	extend : function( base_class, sub_class, props ) {
		if ( typeof props != 'undefined' ) {
			for( var name in props ) {
				if( props.hasOwnProperty(name)) {
					sub_class[name] = props[name];
				}
			}
		}

		for( func in base_class.prototype ) {
			if (!( func in sub_class )) {
				sub_class[func] = base_class.prototype[func];
			} else {
				sub_class['$'+func] = base_class.prototype[func];
			}
		}

		/*
		// put base function to prototype
		if (sub_class.prototype == undefined) {
			sub_class.prototype = {};
		}
		for( func in base_class.prototype ) {
			if (!( func in sub_class.prototype )) {
				sub_class.prototype[func] = base_class.prototype[func];
			} else {
				sub_class.prototype['$'+func] = base_class.prototype[func];
			}
		}
		*/

		if ( 'base' in base_class ) {
			tScope.extend( base_class['base'], sub_class );
		}
	},

	create : function( class_obj, props, complete ) {
		var tobj = Object.create(class_obj.prototype);

		if ( 'base' in tobj ) {
			if ( props == undefined ) {
				props = {};
			}
			tScope.extend( tobj.base, tobj, props );
		}

		if (( 'event' in tobj ) &&
			( 'createBindFunc' in tobj )) {
			tobj.createBindFunc( tobj.event );
		}

		if ( 'init' in tobj ) {
			tobj[tobj.init]();
		}

		if ( typeof complete !== 'undefined' ) {
			complete.call(tobj);
		}

		return tobj;
	},

	loadLang : function( name ) {
		return tScope_lngs[name];
	},

	loadConfig : function( name ) {
		return tScope_cfgs[name];
	}
};
