<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CModule_user_auth extends CModule {

	private $table_name = "user";
	private static $lng_login = array();

	protected function setup() {
		parent::setup();
		CEnv::useLib( "user" );
		CEnv::loadLang( "app.login", self::$lng_login );

		$this->fs = CDatabase::table(
			$this->table_name )->fieldset();
		$table = $this->fs->table;
		CUSess::setup(
			$table->getTablename(),
			$table->getPrimaryKey()
		);
	}

	public function lng_login( $key ) {
		return self::$lng_login[ $key ];
	}

	private function loadFS() {
		if ( !isset( $this->fs ) ) {
			$this->fs = CDatabase::table(
				$this->table_name )->fieldset();
		}
		return $this->fs;
	}

	public function init( $e ) {
		$sys = $this->sys;

		if ( CRoles::hasRole('user') ) {
			return;
		} else {
			if ( $cmd = $sys->getPostCommand() ) {
				switch ( $cmd ) {
				case 'user/auth/auth':
					return;
				}
			}
		}

		$this->sys->clearEventQueue();
		$this->event( 'login' );
	}

	public function login( $e ) {
		$sys = $this->sys;

		$this->loadFS()
			->sel( "login" )
			->sns( "rs" )
			->exe( "request", "get" )
			->sot( "input" );

		$this->outputTemplate( "login" );
	}

	public function auth( $e ) {
		$sys = $this->sys;

		$fs = $this->loadFS()
			->sel( "auth" )
			->sns( "rs" )
			->exe( "request", "get" );

		if ( $fs->validate( "update" ) ) {
			if ( $this->authenticate( $fs ) ) {
				$this->event( "on_login_success", CSys::q_call );
				$sys->clearPostCommand();
				$sys->terminate( 3 );
				return;
			}
		}

		$this->event( "login" );
	}

	public function logoff( $e ) {
		$this->event( "on_logoff", CSys::q_call );
		$sys = $this->sys;
		CUSess::terminate();
		$sys->clearPostCommand();
		$sys->terminate( 3 );
	}

	public function on_login_success( $e ) {
		//-- dummy
	}

	public function on_logoff( $e ) {
		//-- dummy
	}

	private function authenticate( $fs ) {
		$sys = $this->sys;

		$this->getIDPass(
			$fs->table->getTablename(),
			$fs->val( 'username_login' ),
			$user_id,
			$password
		);
		$b_success = ( $password == $fs->val( 'password_login' ) );

		if ( $b_success ) {
			CUSess::start(
				$fs->table->getTablename(),
				$fs->table->getPrimaryKey(),
				$user_id
			);
			return true;
		} else {
			CUInfo::addError($this->lng_login('invalid-credential'));
			return false;
		}
	}

	private function getIDPass( $tabelname, $username, &$user_id, &$password ) {
		$user_id = null;
		$password = null;

		$sqs = array();
		$sqs['verb'] = 'select';
		$sqs['table'] = $tabelname;
		$sqs['expr'][] = 'user_id';
		$sqs['expr'][] = 'password';

		$wh =& $sqs['where'];
			$wh['op'] = 'AND';
			$cond =& $wh['cond'];
				$cond[] = array( 'username', '=', $username );
				$cond[] = array( 'status', '=', 1 );
		$sqs['limit'] = '1';
		$result = CSqo::query( $sqs );
		if ( $rs = CSqo::getRowA( $result ) ) {
			$user_id = $rs['user_id'];
			$password = $rs['password'];
		}
		CSqo::freeResult( $result );

		return !is_null($user_id);
	}
}

?>