<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CModule_user_crud extends CModule {

	private $table_name = "user";
	private static $cfg_params = array();

	protected function setup() {
		CRoles::requireRole('sa');
		parent::setup();
		CState::setup();
		CEnv::useLib( "user" );

		$this->sc = null;
		$this->dt = null;
		$this->fs = null;
	}

	private function loadFS() {
		if ( !isset( $this->fs ) ) {
			$this->fs = CDatabase::table(
				$this->table_name )->fieldset();
		}
		return $this->fs;
	}

	private function loadSC() {
		if ( !isset( $this->sc ) ) {
			$this->sc = CDatabase::table(
				$this->table_name )->fieldset();
		}
		return $this->sc;
	}

	public function search_init( $e ) {
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->set( array(
				"status"=>1,
			) )
			->exe( "request", "get" )
			->exe( "state", "set" );

		$this->event( "search" );
	}
	
	public function search( $e ) {

		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "state", "get" )
			->exe( "state", "clear" )
			->sot( "criteria" );

		$this->b_show_result = $this->sc->validate( "search" );

		if ( $this->b_show_result ) {
			$this->loadFS()
				->sel( "sr" )
				->sns( "rs" )
				->sot( "table" );
			$this->dt = new CDataTable( $this->sc );
		}

		$this->outputTemplate( "search" );
	}

	public function search_pb( $e ) { //-- [Search Button]
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "request", "get" )
			->exe( "state", "set" );

		$this->event( "search" );
	}

	public function search_pxy( $e ) { //-- [To non-search page]
		$this->loadSC()
			->sel( "sc" )
			->sns( "sc" )
			->exe( "request", "get" )
			->exe( "state", "set" );
	}

	public function search_ret( $e ) { //-- [From non-search page]
		CState::clear( "rs:*" );
		CState::clear( "_key:*" );

		$this->event( "search" );
	}

	public function edit_init( $e ) {
		$this->loadFS()
			->sel( "pkey" )
			->sns( "_key" )
			->exe( "request", "get" )
			->exe( "state", "set" )

			->sel( "edit" )
			->sel( "+ne" )
			->exe( "db", "get" )

			->sel( "ne" )
			->sns( "rs" )
			->exe( "state", "set" );

		$this->event( "edit_inp" );
	}

	public function edit_inp( $e ) {
		$this->loadFS()
			->sel( "pkey" )
			->sns( "_key" )
			->exe( "state", "get" )

			->sel( "ne" )
			->sns( "rs" )
			->exe( "state", "get" )

			->sel( "edit" )
			->sns( "rs" )
			->sot( "input" )
			->sot( "html", "ne" );

		$this->outputTemplate( "detail" );
	}

	public function edit_done( $e ) {

		$fs = $this->loadFS()
			->sel( "pkey" )
			->sns( "_key" )
			->exe( "state", "get" )

			->sel( "edit-save" )
			->sns( "rs" )
			->exe( "request", "get" );

		if ( $fs->validate( "update" ) ) {
			$fs
				->sel( "edit-save" )
				->exe( "db", "set" );

			CUInfo::addInfo( $fs->lng( "saved" ) );
		}

		$this->event( "edit_inp" );
	}

	public function reg_init( $e ) {
		$this->loadFS()
			->clr()
			->sel( "reg" )
			->sns( "rs" )
			->set( array( "status"=>1 ) );

		$this->event( "reg_inp" );
	}

	public function reg_inp( $e ) {
		$this->loadFS()
			->sel( "reg" )
			->sns( "rs" )
			->sot( "input" )

			->sel( "ne" )
			->sns( "rs" )
			->sot( "html" );

		$this->outputTemplate( "detail" );
	}

	public function reg_done( $e ) {
		$fs = $this->loadFS()
			->sel( "reg" )
			->sns( "rs" )
			->exe( "request", "get" );

		if ( $fs->validate( "insert" ) ) {

			$fs->set( array(
					'status' => 1,
					'dt_create' => date('Y-m-d H:i:s'),
					) )
				->sel( "reg-save" )
				->exe( "db", "add" );

			CUInfo::addInfo( $fs->lng( "saved" ) );
			$this->event( "reg_init" );
		} else {
			$this->event( "reg_inp" );
		}
	}

	public function del_multi( $e ) {
		$fs = $this->loadFS();

		if ( CDataTable::getSelRec( $selrec ) ) {
			if ( in_array( 1001, $selrec ) ) {
				CUInfo::addError( $fs->lng( "err:can-not-delete-root" ) );
			} else {
				foreach( $selrec as $id ) {
					CDatabase::table($this->table_name )
						->deleteRec(array(
							array("user_id","=",$id)
						));
				}
				CUInfo::addInfo( $fs->lng( "deleted" ) );
			}
		}

		$this->event( "search_ret" );
	}
}

?>