<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CFssExport {

	public static function getTmpPath() {
		global $sys;
		return $sys->getAppPath() . 'tmp/';
	}

	public static function purge() {
		$path_tmp = self::getTmpPath();
		CEnv::loadConfig('fss.export',$cfg);
		foreach( CTmpFile::purge( "fss", $cfg['keep-tmp-interval'] ) as $fn ){
			$path = $path_tmp . $fn;
			if ( file_exists( $path ) ) {
				@unlink( $path );
			}
		}
	}

	private static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			$s .= chr(rand(97, 122));
		}
		return $s;
	}

	private static function createRandomFilename() {
		return date('YmdHis') . '-' . self::createRandomString(20);
	}

	public static function export( $sshow_idx ) {

		global $sys;

		$fss_tmpname = self::createRandomFilename();
		$path_zip = self::getTmpPath() . $fss_tmpname;

		$zip = new CZip();
		if ( $zip->open( $path_zip, ZIPARCHIVE::CREATE ) !== TRUE ) {
			$sys->log( "cannot open `{$path_zip}`" );
		} else {
			if ( count($sshow_idx) == 0 ) {
				echo "no slideshows are selected";
				exit;
			}

			$path_pic = CPic::path();
			$folder_id = 1;
			foreach( $sshow_idx as $sshow_id ) {

				$rs = CDatabase::table( "sshow" )
					->findRec(
						array("dconf"),
						array(array("sshow_id","=",$sshow_id))
					);

				$dcx = json_decode($rs['dconf'],true);
				if ( isset($dcx["sitems"]) ) {

					$idx = 1;
					$ix = array();
					foreach( $dcx["sitems"] as &$sitem ) {
						$fkey_org = $sitem["fkey"];
						if ( $fkey_org != "" ) {
							$path_parts = pathinfo($fkey_org);
							$ext = $path_parts['extension'];
							$fkey_exp = $idx . "." . $ext;
							$sitem["fkey"] = $fkey_exp;

							$zip->addFile( $path_pic . CPic::fn_a($fkey_org),
								"{$folder_id}/pic/" . CPic::fn_a($fkey_exp) );
							$zip->addFile( $path_pic . CPic::fn_m($fkey_org),
								"{$folder_id}/pic/" . CPic::fn_m($fkey_exp) );
							$zip->addFile( $path_pic . CPic::fn_s($fkey_org),
								"{$folder_id}/pic/" . CPic::fn_s($fkey_exp) );
						}
						$idx++;
					}
				}
				$dconf = json_encode($dcx);
				$zip->addFromString( "{$folder_id}/dconf", $dconf );

				$folder_id++;
			}

			$zip->close();

			CTmpFile::add( "fss", $fss_tmpname );

			$fss_filename = "sshow-" . date("Y-m-d-H-i-s") . ".fss";
			self::forceDownload( $path_zip, $fss_filename );
		}
	}

	private static function forceDownload( $path, $fn = null ) {
		if ( $fn == null ) {
			$fn = $path;
		}

		header('Content-Description: File Transfer');
		header('Content-Type: application/octet-stream');
		header('Content-Disposition: attachment; filename=' . basename($fn));
		header('Content-Transfer-Encoding: binary');
		header('Expires: 0');
		header('Cache-Control: must-revalidate');
		header('Pragma: public');
		header('Content-Length: ' . filesize($path));
		if ( ob_get_length() > 0 ) {
			ob_end_clean();
		} 
		@flush();
		readfile($path);
		exit;
	}

}

?>