<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CFssImport {

	private static $current_version = "2.14";
	private static $lng_params = array();
	private static $lng_import = array();

	public function __construct( $prop ) {
		$this->prop =& $prop;
		$this->errmsg = null;
		$this->ext_list = $this->convertListToArray(
			$this->prop['allowed_fileext'] );
		$this->fn_list = array();

		CEnv::loadLang( "file-upload", self::$lng_params );
		CEnv::loadLang( "fss.import", self::$lng_import );
	}

	private static function lng( $key ) {
		return self::$lng_params[ $key ];
	}

	protected function rv( $key ) {
		if ( isset( $_REQUEST[$key] ) ) {
			return $_REQUEST[$key];
		} else {
			return '';
		}
	}

	protected function setErrMsg( $errmsg ) {
		$this->errmsg = $errmsg;
	}

	protected function getErrMsg() {
		return $this->errmsg;
	}

	protected function convertListToArray( $list ) {
		$rx = array();
		$lx = explode( ",", strtolower( $list ) );
		foreach( $lx as $v ) {
			$v = trim( $v );
			if ( $v == '*' ) {
				$rx = null;
				break;
			}
			if ( !empty($v) ) {
				$rx[] = $v;
			}
		}
		return $rx;
	}

	protected function isClassicUpload() {
		return ( isset( $_POST['upload-type'] ) &&
			( $_POST['upload-type'] == 'classic' ));
	}

	protected function returnResponse() {
		$json = json_encode( $this->res );
		if ( $this->isClassicUpload() ) {
			echo "<script>var data={$json};</script>";
		} else {
			echo $json;
		}
	}

	protected static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			$s .= chr(rand(97, 122));
		}
		return $s;
	}

	protected function createRandomFilename() {
		return date('YmdHis') . '-' . self::createRandomString(20);
	}

	protected function checkPostMaxSize() {
		//-- [BEGIN] detect exceeding post_max_size 
		if( empty( $_FILES ) &&
			empty( $_POST ) &&
			isset( $_SERVER['REQUEST_METHOD'] ) &&
			( strtolower($_SERVER['REQUEST_METHOD']) == 'post' )
		) {
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_POST_MAX_SIZE' ) );
			return false;
		}
		//-- [END] detect exceeding post_max_size 

		return true;
	}

	protected function processUpload( &$file ) {

		//-- [BEGIN] PHP file upload error
		$this->err_code = $file['error'];

		switch ( $this->err_code ) {
		case UPLOAD_ERR_OK:
			break;

		case UPLOAD_ERR_INI_SIZE:
			//-- The uploaded file exceeds the upload_max_filesize
			//-- directive in php.ini or .htaccess
			//-- (e.g) php_value upload_max_filesize 20M
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_INI_SIZE' ) );
			return false;

		case UPLOAD_ERR_FORM_SIZE:
			//-- The uploaded file exceeds the MAX_FILE_SIZE directive
			//-- that was specified in the HTML form like
			//-- (e.g) <input type="hidden" name="MAX_FILE_SIZE" value="10000" />
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FORM_SIZE' ) );
			return false;

		case UPLOAD_ERR_PARTIAL:
			//-- The uploaded file was only partially uploaded.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_PARTIAL' ) );
			return false;

		case UPLOAD_ERR_NO_FILE:
			//-- No file was uploaded.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_NO_FILE' ) );
			return false;

		case UPLOAD_ERR_NO_TMP_DIR:
			//-- Missing a temporary folder. Introduced in PHP 4.3.10 and PHP 5.0.3.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_NO_TMP_DIR' ) );
			return false;

		case UPLOAD_ERR_CANT_WRITE:
			//-- Failed to write file to disk. Introduced in PHP 5.1.0.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_CANT_WRITE' ) );
			return false;

		case UPLOAD_ERR_EXTENSION:
			//-- File upload stopped by php extension(s).
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_EXTENSION' ) );
			return false;

		default:
			//-- General Failure
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_GENERAL_FAILURE' ) );
			return false;
		}
		//-- [END] PHP file upload error

		//-- check if it's empty
		if ( empty( $file['name'] ) ) {
			//-- The filename was not selected."
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FILENAME_NOT_SELECTED' ) );
			return false;
		}

		//-- check filesize
		if ( $file['size'] > $this->prop['max_filesize'] ) {
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FILESIZE' ) );
			return false;
		}

		//-- $path parts
		$path_parts = pathinfo($file['name']);

		//-- check extension
		if ( !is_null( $this->ext_list ) ) {
			if ( empty($path_parts['extension']) ||
					!in_array( strtolower($path_parts['extension']), $this->ext_list ) ) {
				$this->setErrMsg( str_replace( "##ext##", $path_parts['extension'],
					self::lng( 'CFILEUPLOAD_ERR_INVALID_FILE_TYPE' ) ) );
				return false;
			}
		}

		//-- import
		$this->import_fss( $file['tmp_name'] );

		//-- record filename
		//$this->fn_list[] = $fn;

		return true;
	}

	protected function renderFileList() {
		//$this->res['fn_list'] = $this->fn_list;
	}

	protected function process() {

		if ( !$this->checkPostMaxSize() ) {
			return false;
		}

		foreach( $_FILES as $key => &$file ) {
			if ( !$this->processUpload( $file ) ) {
				return false;
			}
		}

		$this->renderFileList();

		return true;
	}

	public function run() {

		$this->res = array();
		$this->process();

		if ( $errmsg = $this->getErrMsg() ) {
			$this->res['result'] = $errmsg;
		} else {
			$this->res['result'] = 'OK';
		}

		$this->returnResponse();
	}

	protected static function import_file( $path_dest, $fp ) {
		$contents = '';
		while ( !feof($fp) ) {
			$contents .= fread($fp, 10000);
		}
		fclose($fp);

		file_put_contents($path_dest,$contents);
	}

	private function checkVersion( $ver ) {
		$invalid_version = "err:invalid-version";
		$newer_version = "err:newer-version";
		$prefix = "fss-";

		if ( substr($ver,0,strlen($prefix)) != $prefix ) {
			$this->setErrMsg( self::$lng_import[ $invalid_version ] );
			return false;
		}
		$verno = substr($ver,strlen($prefix));
		if ( !is_numeric($verno) ) {
			$this->setErrMsg( self::$lng_import[ $invalid_version ] );
			return false;
		}
		$verf = floatval($verno);
		$verf_cur = floatval(self::$current_version);
		if ( $verf > $verf_cur ) {
			$this->setErrMsg( self::$lng_import[ $newer_version ] );
			return false;
		}
		return true;
	}

	private function upgradeVersionFormat( &$dcx ) {
		$prefix = "fss-";
		$ver = isset($dcx['ver']) ? $dcx['ver'] : null;
		$verno = substr($ver,strlen($prefix));
		$verf = floatval($verno);
		$verf_cur = floatval(self::$current_version);

		if ( $verf >= $verf_cur ) {
			//-- no conversion
			return;
		}

		if ( $verf < 2.14 ) {
			CFileUpgrade200to214::process($dcx);
			$dcx['ver'] = "{$prefix}2.14";
			$verf = 2.14;
		}

//		if ( $verf < 2.XX ) {
//			CFileUpgrade200to2XX::process($dcx);
//			$dcx['ver'] = "{$prefix}2.XX";
//			$verf = 2.XX;
//		}
	}

	protected function import_fss( $path ) {
		$path_pic = CPic::path();

		$zip = new CZip;
		$res = $zip->open( $path );
		if ($res === TRUE) {

			//-- [BEGIN] read dconf
			$fss = array();
			for ($i=0; $i<$zip->numFiles;$i++) {

				$stat = $zip->statIndex($i);
				$name = $stat['name'];
				$sx = explode( "/", $name );

				$idx = intval($sx[0]);

				if (
					( $idx != 0 ) &&
					( count($sx) == 2 ) &&
					( $sx[1] == 'dconf' )
				) { 
					$fss[$idx] = $zip->getFromName($name);
				}
			}
			//-- [END] read dconf

			//-- [BEGIN] import dconf
			ksort($fss);
			foreach( $fss as $idx => $dconf ){

				$dcx = json_decode($dconf,true);

				$ver = isset($dcx['ver']) ? $dcx['ver'] : null;
				if ( !$this->checkVersion( $ver ) ) {
					return;
				}

				$this->upgradeVersionFormat( $dcx );

				$status = ( isset($dcx['status']) ? $dcx['status'] : 1 );
				$title = ( isset($dcx['title']) ? $dcx['title'] : '?' );

				//-- [BEGIN] import pics
				if ( isset( $dcx['sitems'] ) ) {
					foreach( $dcx['sitems'] as &$sitem ) {
						if ( isset($sitem['fkey']) ) {
							$fkey_org = $sitem['fkey'];
							if ( $fkey_org != "" ) {
								$parts = pathinfo($fkey_org);
								$ext = $parts['extension'];
								$fn = self::createRandomFilename();
								$fkey_new = $fn . '.' . $ext;
								$sitem['fkey'] = $fkey_new;

								$fp = $zip->getStream("{$idx}/pic/" . CPic::fn_a($fkey_org));
								$path_dest = $path_pic . CPic::fn_a($fkey_new);
								self::import_file( $path_dest, $fp );

								$fp = $zip->getStream("{$idx}/pic/" . CPic::fn_m($fkey_org));
								$path_dest = $path_pic . CPic::fn_m($fkey_new);
								self::import_file( $path_dest, $fp );

								$fp = $zip->getStream("{$idx}/pic/" . CPic::fn_s($fkey_org));
								$path_dest = $path_pic . CPic::fn_s($fkey_new);
								self::import_file( $path_dest, $fp );
							}
						}
					}
				}
				//-- [END] import pics

				$dconf = json_encode($dcx);
				CDatabase::table( "sshow" )
					->insertRec( array(
						'dt_create' => date('Y-m-d H:i:s'),
						'status' => $status,
						'title' => $title,
						"dconf"=>$dconf,
					));
			}
			//-- [END] import dconf

			$zip->close();
		} else {
			$this->setErrMsg( self::$lng_import[ 'err:can-not-open-file' ] );
		}
	}
}

?>