<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CPicUpload {

	private static $lng_params = array();
	private static $lng_pic = array();

	public function __construct( $prop ) {
		$this->prop =& $prop;
		$this->errmsg = null;
		$this->ext_list = $this->convertListToArray(
			$this->prop['allowed_fileext'] );
		$this->fkey_list = array();

		CEnv::loadLang( "file-upload", self::$lng_params );
		CEnv::loadLang( "sshow.pic", self::$lng_pic );
	}

	private static function lng( $key ) {
		return self::$lng_params[ $key ];
	}

	protected function rv( $key ) {
		if ( isset( $_REQUEST[$key] ) ) {
			return $_REQUEST[$key];
		} else {
			return '';
		}
	}

	protected function setErrMsg( $errmsg ) {
		$this->errmsg = $errmsg;
	}

	protected function getErrMsg() {
		return $this->errmsg;
	}

	protected function convertListToArray( $list ) {
		$rx = array();
		$lx = explode( ",", strtolower( $list ) );
		foreach( $lx as $v ) {
			$v = trim( $v );
			if ( $v == '*' ) {
				$rx = null;
				break;
			}
			if ( !empty($v) ) {
				$rx[] = $v;
			}
		}
		return $rx;
	}

	protected function isClassicUpload() {
		return ( isset( $_POST['upload-type'] ) &&
			( $_POST['upload-type'] == 'classic' ));
	}

	protected function returnResponse() {
		$json = json_encode( $this->res );
		if ( $this->isClassicUpload() ) {
			echo "<script>var data={$json};</script>";
		} else {
			echo $json;
		}
	}

	protected static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			$s .= chr(rand(97, 122));
		}
		return $s;
	}

	protected function createRandomFilename() {
		return date('YmdHis') . '-' . self::createRandomString(20);
	}

	protected function checkPostMaxSize() {
		//-- [BEGIN] detect exceeding post_max_size 
		if( empty( $_FILES ) &&
			empty( $_POST ) &&
			isset( $_SERVER['REQUEST_METHOD'] ) &&
			( strtolower($_SERVER['REQUEST_METHOD']) == 'post' )
		) {
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_POST_MAX_SIZE' ) );
			return false;
		}
		//-- [END] detect exceeding post_max_size 

		return true;
	}

	protected function convertSize( $path_src, $path_des, $w_max, $h_max, $mode, $ext ) {
		$src = @imagecreatefromstring( @file_get_contents($path_src) );
		$w_src_ct = imagesx($src);
		$h_src_ct = imagesy($src);

		if ( $w_max == -1 ) {
			$w_max = $w_src_ct;
		}

		if ( $h_max == -1 ) {
			$h_max = $h_src_ct;
		}

		switch ( $mode ) {

		case "pad":// maintain aspect ratio, pad it to max
		case 'fit':// maintain aspect ratio, fit inside max
			if (( $w_src_ct <= $w_max ) && ( $h_src_ct <= $h_max )) {
				$w_des = $w_src_ct;
				$h_des = $h_src_ct;
			} else if (( $w_src_ct > $w_max ) && ( $h_src_ct > $h_max )) {
				$w_des = round(($h_max / $h_src_ct) * $w_src_ct);
				if ( $w_max >= $w_des ) {
					$h_des = $h_max;
				} else {
					$w_des = $w_max;
					$h_des = round(($w_max / $w_src_ct) * $h_src_ct);
				}
			} else if ( $w_src_ct > $w_max ) {
				$w_des = $w_max;
				$h_des = round(($w_max / $w_src_ct) * $h_src_ct);
			} else {
				$w_des = round(($h_max / $h_src_ct) * $w_src_ct);
				$h_des = $h_max;
			}
			if ( $mode == 'pad' ) {
				$w_des_ct = $w_max;
				$h_des_ct = $h_max;
			} else {
				$w_des_ct = $w_des;
				$h_des_ct = $h_des;
			}
			$x_des = round(($w_des_ct - $w_des) / 2);
			$y_des = round(($h_des_ct - $h_des) / 2);

			$x_src = 0;
			$y_src = 0;
			$w_src = $w_src_ct;
			$h_src = $h_src_ct;
			break;

		case "fill":// fill the area by cropping
			if (( $w_src_ct / $h_src_ct ) >= ( $w_max / $h_max )) {
				$w_src = round( ( $w_max / $h_max ) * $h_src_ct );
				$h_src = $h_src_ct;
				$x_src = round( ( $w_src_ct - $w_src ) / 2 );
				$y_src = 0;
			} else {
				$w_src = $w_src_ct;
				$h_src = round( ( $h_max / $w_max ) * $w_src_ct );
				$x_src = 0;
				$y_src = round( ( $h_src_ct - $h_src ) / 2 );
			}
			$x_des = 0;
			$y_des = 0;
			$w_des = $w_max;
			$h_des = $h_max;
			$w_des_ct = $w_des;
			$h_des_ct = $h_des;
			break;

		case "map":// ignore the aspect ratio and fill the area
			$x_des = 0;
			$y_des = 0;
			$w_des = $w_max;
			$h_des = $h_max;
			$w_des_ct = $w_des;
			$h_des_ct = $h_des;

			$x_src = 0;
			$y_src = 0;
			$w_src = $w_src_ct;
			$h_src = $h_src_ct;
			break;
		}

		$des = @imagecreatetruecolor($w_des_ct, $h_des_ct);

		switch( $ext ) {
		case "jpg": // fill in white
			$color = imagecolorallocatealpha($des, 255, 255, 255, 0);
			imagefilledrectangle($des, 0, 0, $w_des_ct, $h_des_ct, $color);
			break;

		case "png": // png alpha channel
			imagealphablending($des, false);
			imagesavealpha($des, true);

			$color = imagecolorallocatealpha($des, 255, 255, 255, 127);
			imagefilledrectangle($des, 0, 0, $w_des_ct, $h_des_ct, $color);
			break;
		}

		imagecopyresampled( $des, $src,
			$x_des, $y_des,
			$x_src, $y_src,
			$w_des, $h_des,
			$w_src, $h_src
		);

		switch( $ext ) {
		case "jpg":
			// The default quality setting on most IJG packages
			// (including ImageMagick used on photo.net) is 75,
			// which gives a good tradeoff between file size and
			// perceived quality.
			@imagejpeg( $des, $path_des );
			break;

		case "png":
			@imagepng( $des, $path_des );
			break;
		}

		imagedestroy($des);
		imagedestroy($src);
	}

	protected function processUpload( &$file ) {

		//-- [BEGIN] PHP file upload error
		$this->err_code = $file['error'];

		switch ( $this->err_code ) {
		case UPLOAD_ERR_OK:
			break;

		case UPLOAD_ERR_INI_SIZE:
			//-- The uploaded file exceeds the upload_max_filesize
			//-- directive in php.ini or .htaccess
			//-- (e.g) php_value upload_max_filesize 20M
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_INI_SIZE' ) );
			return false;

		case UPLOAD_ERR_FORM_SIZE:
			//-- The uploaded file exceeds the MAX_FILE_SIZE directive
			//-- that was specified in the HTML form like
			//-- (e.g) <input type="hidden" name="MAX_FILE_SIZE" value="10000" />
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FORM_SIZE' ) );
			return false;

		case UPLOAD_ERR_PARTIAL:
			//-- The uploaded file was only partially uploaded.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_PARTIAL' ) );
			return false;

		case UPLOAD_ERR_NO_FILE:
			//-- No file was uploaded.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_NO_FILE' ) );
			return false;

		case UPLOAD_ERR_NO_TMP_DIR:
			//-- Missing a temporary folder. Introduced in PHP 4.3.10 and PHP 5.0.3.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_NO_TMP_DIR' ) );
			return false;

		case UPLOAD_ERR_CANT_WRITE:
			//-- Failed to write file to disk. Introduced in PHP 5.1.0.
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_CANT_WRITE' ) );
			return false;

		case UPLOAD_ERR_EXTENSION:
			//-- File upload stopped by php extension(s).
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_EXTENSION' ) );
			return false;

		default:
			//-- General Failure
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_GENERAL_FAILURE' ) );
			return false;
		}
		//-- [END] PHP file upload error

		//-- check if it's empty
		if ( empty( $file['name'] ) ) {
			//-- The filename was not selected."
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FILENAME_NOT_SELECTED' ) );
			return false;
		}

		//-- check filesize
		if ( $file['size'] > $this->prop['max_filesize'] ) {
			$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_FILESIZE' ) );
			return false;
		}

		//-- $path parts
		$path_parts = pathinfo($file['name']);

		//-- check extension
		if ( !is_null( $this->ext_list ) ) {
			if ( empty($path_parts['extension']) ||
					!in_array( strtolower($path_parts['extension']), $this->ext_list ) ) {
				$this->setErrMsg( str_replace( "##ext##", $path_parts['extension'],
					self::lng( 'CFILEUPLOAD_ERR_INVALID_FILE_TYPE' ) ) );
				return false;
			}
		}

		//-- image file check
		$path = $file['tmp_name'];
		list( $img_width, $img_height ) = getimagesize( $path );
		if ( !isset( $img_width ) || !isset( $img_height ) ) {
			$this->setErrMsg( self::$lng_pic[ 'err:can-not-load-image' ] );
			return false;
		}

		//-- normalize extension
		$ext = strtolower($path_parts['extension']);
		switch( $ext ) {
		case "png":
			break;

		case "jpg":
		case "jpeg":
			$ext = "jpg";
			break;

		default:
			$ext = "png";
			break;
		}

		//-- move file
		$fn = $this->createRandomFilename();
		$src_path = $file['tmp_name'];
		foreach( $this->prop['sizes'] as $key => $size ) {
			$des_path = $this->prop['path_storage'] . $fn . "-" . $key . '.' . $ext;

			$this->convertSize( $src_path, $des_path,
				$size['w'], $size['h'], $size['mode'], $ext );

			//-- check if the file was created
			if ( !file_exists($des_path) ) {
				$this->setErrMsg( self::lng( 'CFILEUPLOAD_ERR_MOVE_UPLOADED_FILE' ) );
				return false;
			}
		}

		//-- record fkey
		$fkey = $fn . '.' . $ext;
		$this->fkey_list[] = $fkey;
		CTmpFile::add('pic',$fkey);

		return true;
	}

	protected function renderFileList() {
		$this->res['fkey_list'] = $this->fkey_list;
	}

	protected function process() {

		if ( !$this->checkPostMaxSize() ) {
			return false;
		}

		$idx = 0;
		foreach( $_FILES as $key => &$file ) {
			if ( !$this->processUpload( $file ) ) {
				return false;
			}
			$idx++;
			if ( $idx == 1 ) {
				break;
			}
		}

		$this->renderFileList();

		return true;
	}

	public function run() {

		$this->res = array();
		$this->process();

		if ( $errmsg = $this->getErrMsg() ) {
			$this->res['result'] = $errmsg;
		} else {
			$this->res['result'] = 'OK';
		}

		$this->returnResponse();
	}
}

?>