<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CSShow extends CSShowCore {

	private static $table_name = "sshow";
	private static $file_prefix = "sshow-";

	public static function getCacheUrl() {
		global $sys;
		return $sys->getAppUrl() . 'cache/';
	}

	public static function getCachePath() {
		global $sys;
		return $sys->getAppPath() . 'cache/';
	}

	public function getCnUrl() {
		global $sys;
		return $sys->getAppUrl() . 'cn/';
	}

	public static function saveCache( $fsskey, $content ) {
		$path = self::getCachePath() . self::$file_prefix . $fsskey . ".cache";
		file_put_contents( $path, $content );
	}

	public static function deleteCache( $fsskey ) {
		$path = self::getCachePath() . self::$file_prefix . $fsskey . ".cache";
		if ( file_exists( $path ) ) {
			@unlink( $path );
		}
	}

	private function printJs( $fsskey ) {

		$this_sig = "<!--$(this)-->";

		$tbl = CDatabase::table( self::$table_name );
		if (!( $rs = $tbl->findRec( array("dconf"), array(
			array( 'sshow_id', '=', $fsskey ),
		)))) {
			return false;
		}

		$dcx = json_decode($rs["dconf"],true);
		if ( $dcx['status'] == 0 ) {
			return false;
		}

		$settings = array();
		$settings['jqo_player'] = $this_sig;
		$settings['url_img'] = $this->getCnUrl() . 'img/';

		$settings['slide_width'] = $dcx['width'];
		$settings['slide_height'] = $dcx['height'];
		$settings['slide_height'] = $dcx['height'];
		$settings['ptime'] = $dcx['pause-duration'];
		$settings['ttime'] = $dcx['trans-duration'];
		$settings['teffect'] = $dcx['effect-type'];
		if ( $dcx['clickable'] == 1 ) {
			if ( !empty( $dcx['dest-url'] ) ) {
				$settings['href'] = $dcx['dest-url'];
				if ( $dcx['open-tab'] == 1 ) {
					$settings['target'] = "_blank";
				}
			}
		}
		$settings['b_loop'] = ( $dcx['loop'] == 1 );
		$settings['b_auto_start'] = ( $dcx['auto_start'] == 1 );
		$settings['b_max_width'] = true;
		$settings['startbtn_visible'] = $dcx['startbtn_visible'];
		$settings['playnav_visible'] = $dcx['playnav_visible'];
		$settings['dirnav_visible'] = $dcx['dirnav_visible'];
		$settings['pager_visible'] = $dcx['pager_visible'];

		$url_pic = CPic::url();
		$slidelist = array();
		foreach( $dcx['sitems'] as &$sitem ) {

			$slide = array();
			$slide['src'] = $url_pic . CPic::fn_a($sitem['fkey']);
			if ( isset($sitem['pause-duration']) &&
				( $sitem['pause-duration'] != "" ) ) {
				$slide['ptime'] = $sitem['pause-duration'];
			}
			if ( isset($sitem['trans-duration']) &&
				( $sitem['trans-duration'] != "" ) ) {
				$slide['ttime'] = $sitem['trans-duration'];
			}
			if ( !empty($sitem['effect-type']) ) {
				$slide['teffect'] = $sitem['effect-type'];
			}
			if ( $sitem['clickable'] == 1 ) {
				if ( !empty( $sitem['dest-url'] ) ) {
					$slide['href'] = $sitem['dest-url'];
					if ( $sitem['open-tab'] == 1 ) {
						$slide['target'] = "_blank";
					}
				}
			}
			$slidelist[] = $slide;
		}
		$settings['slidelist'] = $slidelist;

		$this->printJsCore( $fsskey, $settings, $this_sig );

		return true;
	}

	public static function render( $fsskey ) {

		$sshow = new CSShow();

		$txt = null;
		ob_start();
		if ( $sshow->printJs( $fsskey ) ) {
			$txt = ob_get_contents();
		}
		ob_end_clean();

		if ( $txt ) {

			//-- minimize
			$txt = str_replace("\r",'',$txt);
			$txt = str_replace("\n",'',$txt);
			$txt = str_replace("\t",'',$txt);

			//-- save cache
			$sshow->saveCache( $fsskey, $txt );
			return true;

		} else {
			$sshow->deleteCache( $fsskey );
			return false;
		}
	}
}

?>