<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CComponent extends CObject {

	public function __construct( $prt, $name, $path_comp ) {
		parent::__construct( $prt );

		$this->name = $name;
		$this->path_comp = $path_comp;
		$this->modules = array();
	}

	public function getFolderPath() {
		return $this->prt->getFolderPath() . $this->name . '/';
	}

	public function getFolderUrl() {
		return $this->prt->getFolderUrl() . $this->name . '/';
	}

	public function getModule( $mod_name ) {
		if ( isset( $this->modules[$mod_name] ) ) {
			$mod =& $this->modules[$mod_name];
		} else {
			$class_name = "CModule_{$this->name}_{$mod_name}";
			if ( !class_exists( $class_name, false ) ) {
				$path = "{$this->path_comp}{$mod_name}/index.inc.php";
				if ( !is_file( $path ) ) {
					trigger_error( "Can not find file [$path]", E_USER_ERROR );
				}
				require_once( $path );
			}
			$this->modules[$mod_name] = new $class_name( $this, $mod_name );
			$mod =& $this->modules[$mod_name];
		}

		return $mod;
	}

	public function registerBind( $bind, $mode ) {
		if ( empty( $bind->comp_name_src ) ) {
			$bind->comp_name_src = $this->name;
		}
		if ( empty( $bind->comp_name_des ) ) {
			$bind->comp_name_des = $this->name;
		}
		return $this->prt->registerBind( $bind, $mode );
	}

	public function registerEvent( $e, $mode ) {
		if ( empty( $e->comp_name ) ) {
			$e->comp_name = $this->name;
		}
		return $this->prt->registerEvent( $e, $mode );
	}

	public function processEvent( $e ) {
		$mod = $this->getModule( $e->mod_name );
		if ( method_exists( $mod, $e->action ) ) {
			return call_user_func_array( array( $mod, $e->action ), array( $e ) );
		} else {
			trigger_error( "method does not exist " . 
				"(CModule_{$this->name}_{$e->mod_name}::{$e->action})",
				E_USER_ERROR );
		}
	}
}

?>