<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CDataTable {

	public function __construct( $sc ) {
		$this->sc = $sc;
		$this->idx = 0;
	}

	private function getParam( $key, $val ) {
		$fkey = "_dt:{$key}";
		if ( isset( $_REQUEST[ $fkey ] ) ) {
			$v = $_REQUEST[ $fkey ];
		} else {
			$v = CState::get( $fkey );
			if ( is_null( $v ) ) {
				$v = $val;
			}
		}
		return $v;
	}

	private function setParam( $key, $val ) {
		$fkey = "_dt:{$key}";
		$this->params[ $key ] = $val;
		CState::set( $fkey, $val );
	}

	public function setup( $page_index, $rows_per_page, $order_by ) {

		//-- page index
		$v = $this->getParam( "pi", $page_index );
		$v = intval( $v );
		if ( $v <= 0 ) {
			$v = 1;
		}
		$this->setParam( "pi", $v );

		//-- rows per page
		$v = $this->getParam( "rpp", $rows_per_page );
		$v = intval( $v );
		if ( $v <= 0 ) {
			$v = 10;
		}
		$this->setParam( "rpp", $v );

		//-- order by
		$v = $this->getParam( "ob", $order_by );
		$x = explode( "!", $v );
		if ( count( $x ) == 2 ) {
			if (( $x[1] == "ASC" ) || ( $x[1] == "DESC" )) {
				if ( !array_key_exists( $x[0], $this->sc->table->fdx ) ) {
					$v = null;
				}
			}
		}
		$this->setParam( "ob", $v );

		//-- get total records
		$this->sqs = array();

		$sqs =& $this->sqs;
		$sqs['verb'] = 'select';
		$sqs['table'] = $this->sc->table->getTablename();
		$wh =& $sqs['where'];
			$wh['op'] = 'AND';
			$cond =& $wh['cond'];
			foreach( $this->sc->fdx as $fname ) {
				$fd =& $this->sc->table->fdx[ $fname ];
				if ( !isset( $fd[ 'search-key' ] ) ) {
					trigger_error( "[{$fname}] Missing search-key", E_USER_ERROR );
				}
				$v = $this->sc->val( $fname );
				if ( !CFieldSet::isEmptyString( $v ) ) {
					$cond[] = array( $this->sc->getDname( $fname ),
						$fd[ 'search-key' ],
						$v );
				}
			}

		$result = CSqo::query( $sqs );
		$this->total_rows = CSqo::getRowCount( $result );
		CSqo::freeResult( $result );
	}

	private function buildSubquery( $fs1, &$tlink ) {
		$tbl2 = CDatabase::table( $tlink["table"] );
		$fs2 = $tbl2->fieldset();

		$cond = $tlink["cond"];

		$x1 = explode(".",$cond[0]);
		if ( $x1[0] == 'T1' ) {
			$x1[1] = $fs1->getDname($x1[1]);
		} else {
			$x1[1] = $fs2->getDname($x1[1]);
		}
		$cond[0] = implode(".",$x1);

		$x2 = explode(".",$cond[2]);
		if ( $x2[0] == 'T1' ) {
			$x2[1] = $fs1->getDname($x2[1]);
		} else {
			$x2[1] = $fs2->getDname($x2[1]);
		}
		$cond[2] = implode(".",$x2);

		$sqs = array();
		$sqs['verb'] = 'select';
		$sqs['table'] = $tbl2->getTablename();

		$fname = $tlink["fname"];
		if ( is_array( $fname ) ) {
			foreach( $fname as $k => $v ) {
				$sqs['expr'][$k] = $fs2->getDname( $v );
			}
		} else {
			$sqs['expr'][] = $fs2->getDname( $fname );
		}

		$sqs['where'] = $cond;
		$sql = "(" . CSqo::renderSql( $sqs, "T2" ) . ")";

		return $sql;
	}

	public function getData( $fs ) {

		if ( $this->idx == 0 ) {

			$sqs =& $this->sqs;
			$ep =& $sqs['expr'];
				foreach( $fs->fdx as $fname ) {
					$fd =& $fs->table->fdx[ $fname ];
					$dname = $fs->getDname( $fname );
					if ( isset( $fd[ 'tlink' ] ) ) {
						$ep[ $this->buildSubquery( $fs, $fd[ 'tlink' ] ) ] = $dname;
					} else if ( isset( $fd[ 'subquery' ] ) ) {
						$ep[ $fd[ 'subquery' ] ] = $dname;
					} else {
						$ep[] = $dname;
					}
				}

			if ( !empty( $this->params[ 'ob' ] ) ) {
				$ob =& $sqs['orderby'];
				$x = explode( "!", $this->params[ 'ob' ] );
					$ob[ $fs->getDname( $x[0] ) ] = $x[1];
			}

			$sqs['limit'] = $this->params[ 'rpp' ];
			$sqs['offset'] = ( $this->params[ 'pi' ] - 1 ) * $this->params[ 'rpp' ];

			$this->result = CSqo::query( $sqs );
		}

		$this->idx++;

		$b = $fs->setRowResult( $this->result );

		return $b;
	}

	public function sortBtn( $fname ) {

		$ob = !empty( $this->params[ 'ob' ] ) ?
			$this->params[ 'ob' ] : null;

		$asc = (( $ob ) && ( $ob == "{$fname}!ASC" ));
		$desc = (( $ob ) && ( $ob == "{$fname}!DESC" ));

		return array( $asc, $desc );
/*
		$ob = !empty( $this->params[ 'ob' ] ) ?
			$this->params[ 'ob' ] : null;

		$s = "";

		$c = (( $ob ) && ( $ob == "{$fname}!ASC" )) ? "▲" : "△";

		$s .= "<a class='dt-sort-btn btn-event' ";
		$s .= "cmd='search_pb?_dt:pi=1&_dt:ob={$fname}!ASC' ";
		$s .= "href='' title='" . $this->lng( "title-asc" ) . "'>{$c}</a>";

		$c = (( $ob ) && ( $ob == "{$fname}!DESC" )) ? "▼" : "▽";

		$s .= "<a class='dt-sort-btn btn-event' ";
		$s .= "cmd='search_pb?_dt:pi=1&_dt:ob={$fname}!DESC' ";
		$s .= "href='' title='" . $this->lng( "title-desc" ) . "'>{$c}</a>";

		$s = "<span class='dt-sort-btns'>{$s}</span>";

		return $s;
*/
	}

	public function getStats() {
		$sidx = ( $this->params[ 'pi' ] - 1 ) * $this->params[ 'rpp' ] + 1;
		$eidx = $sidx + $this->params[ 'rpp' ] - 1;
		if ( $eidx > $this->total_rows ) {
			$eidx = $this->total_rows;
		}
		return array( $sidx, $eidx, $this->total_rows );
	}

	public function getPageIndex() {
		return $this->params[ 'pi' ];
	}

	public function getPageTotal() {
		return ceil( $this->total_rows / $this->params[ 'rpp' ] );
	}

	public static function getSelRec( &$selrec ) {
		$selrec = array();
		if ( isset( $_REQUEST[ '_selrec_' ] ) ) {
			$ax = $_REQUEST[ '_selrec_' ];
			if ( is_array( $ax ) ) {
				foreach( $ax as $v ) {
					$v = trim( $v );
					$selrec[] = intval( $v );
				}
			}
		}

		return count( $selrec );
	}

	public static function deleteSelRec( $fs, &$selrec ) {

		if ( count( $selrec ) == 0 ) {
			trigger_error( "No checkboxes are selected", E_USER_ERROR );
		}

		$pkey = $fs->table->getPrimaryKey();
		$pkey_dname = $fs->getDname( $pkey );

		CSqo::open();

		$sqs = array();
		$sqs['verb'] = 'delete';
		$sqs['table'] = $fs->table->getTablename();
		$wh =& $sqs['where'];
			$wh['op'] = 'OR';
			$cond =& $wh['cond'];
				foreach( $selrec as $v ) {
					$cond[] = array( $pkey_dname,
					"=", $v );
				}

		return CSqo::query( $sqs );
	}
}

?>