<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CEmail {

	const HERE_DOC_KEY = "=<<<";
	const SMTP_TIMEOUT = 30;
	const LOG_MULTI_PART_DATA = false;
	const INTERNAL_ENCODING = "utf-8"; // utf-8, euc-jp

	var $params = array();

	public static function getVersion() {
		return "CEmail v1.60";
	}

	//----------------------------------------------------------------
	// mbstr
	//----------------------------------------------------------------
	private static function replace( $s1, $s2, $s3 ) {
		mb_regex_encoding( self::INTERNAL_ENCODING );
		return mb_ereg_replace( $s1, $s2, $s3 );
	}

	private static function split( $pattern, $s ) {
		mb_regex_encoding( self::INTERNAL_ENCODING );
		return mb_split( $pattern, $s );
	}

	private static function strpos( $s, $find_this, $offset = 0 ) {
		return mb_strpos( $s, $find_this, $offset, self::INTERNAL_ENCODING );
	}

	private static function strrpos( $s, $find_this, $offset = 0 ) {
		return mb_strrpos( $s, $find_this, $offset, self::INTERNAL_ENCODING );
	}

	private static function strlen( $s ) {
		return mb_strlen( $s, self::INTERNAL_ENCODING );
	}

	private static function substr( $s1, $s2, $s3 ) {
		return mb_substr( $s1, $s2, $s3, self::INTERNAL_ENCODING );
	}

	private static function splite( $s, &$key, &$val ) {
		$pos = self::strpos( $s, '=' );
		if ( $pos !== false ) {
			$key = self::substr( $s, 0, $pos );
			$val = self::substr( $s, 
				self::strlen( $s ) - ( self::strlen( $s ) - $pos ) + 1,
				self::strlen($s) );
		} else {
			$key = $s;
			$val = $s;
		}
	}

	//----------------------------------------------------------------
	// helper functions
	//----------------------------------------------------------------
	private static function readEmailAddresses( $ln ) {
		$emails = array();
		if ( !empty( $ln ) ) {
			$ax = explode( "|", $ln );
			foreach ( $ax as $s ) {
				$s = trim( $s );
				if ( self::strlen( $s ) > 0 ) {
					$emails[] = self::readEmailAddress( $s );
				}
			}
		}
		return $emails;
	}

	private static function readEmailAddress( $ln ) {
		//-- (e.g) John Smith <john@smith.com>
		$ln = trim($ln);
		$pat = '^([^<]+)<([^>]+)>$';
		mb_regex_encoding( "UTF-8" );
		$ax = array();
		if ( mb_ereg( $pat, $ln, $matches ) ) {
			$ax[] = trim( $matches[2] );
			$ax[] = self::replace( ",", "\\," , trim( $matches[1] ) );
		} else {
			$ax[] = $ln;
		}
		return $ax;
	}

	private static function splitByE( $ln, &$key, &$val ) {
		$pos = self::strpos( $ln, '=' );
		if ( $pos === false ) {
			$key = trim( $ln );
			$val = '';
		} else {
			$key = trim( self::substr( $ln, 0, $pos ) );
			$val = self::substr( $ln, $pos+1, self::strlen($ln) );
		}
	}

	private static function getFolderPath( $path ) {
		$path_parts = pathinfo( $path );
		$dirname = $path_parts[ 'dirname' ];
		return $dirname . '/';
	}

	private static function base64EncodeAndSplit( $s ) {
		return chunk_split( base64_encode( $s ), 72 );
	}

	private function getEmailEncoding() {
		return "utf-8";
	}

	//----------------------------------------------------------------
	// email configuration
	//----------------------------------------------------------------
	public function openConfig( $path, $b_direct_config = false ) {
		if ( $b_direct_config ) {
			$txt = $path;
		} else {
			if ( !file_exists( $path ) ) {
				trigger_error( "Can not find config file : {$path}", E_USER_ERROR );
			}
			$txt = file_get_contents( $path );
		}

		$txt = self::replace( "\r\n", "\n", $txt );
		$tx = self::split( "\n", $txt );
		$params = array();
		$params[ "Encoding" ] = "UTF-8";

		$multi_line_key = "";
		$multi_line_end = "";
		$multi_line = "";
		foreach ( $tx as $ln ) {
			if ( $multi_line_end != "" ) {
				if ( trim($ln) == $multi_line_end ) {
					$params[$multi_line_key] = $multi_line;
					$multi_line_end = "";
				} else {
					$multi_line .= $ln . "\r\n";
				}
			} else {
				if ( self::substr( $ln, 0, 2 ) != "//" ) {
					$pos = self::strpos( $ln, self::HERE_DOC_KEY );
					if ( $pos !== false ) {
						$multi_line_key = trim( self::substr( $ln, 0, $pos ));
						$multi_line_end = trim( self::substr( $ln, $pos+strlen( self::HERE_DOC_KEY ), self::strlen($ln) ) );
						$multi_line = "";
					} else if ( trim( $ln ) != "" ) {
						$this->splitByE( $ln, $key, $val );
						if ( $key == "Inherits" ) {
							$path_x = $this->getFolderPath($path) . $val;
							if ( file_exists( $path_x ) ) {
								$this->openConfig( $path_x );
							} else {
								trigger_error( "Can not find include config file : {$path_x}", E_USER_ERROR );
							}
						} else if ( self::substr( $key, 0, 1 ) == "!" ) {
							$this->headers[ substr($key,1) ] = $val;
						} else {
							$params[$key] = $val;
						}
					}
				}
			}
		}

		$ls = array( "From", "To", "Reply-To", "Cc" , "Bcc", "Attachment" );
		foreach ( $ls as $key ) {
			$this->loadEmailLine( $key, $params[$key] );
		}
/*
		foreach ( $ls as $key ) {
			if ( isset( $params[$key] ) ) {
				$ax = explode( "|", $params[$key] );
				$ax2= array();
				foreach ( $ax as $s ) {
					$s = trim( $s );
					if ( self::strlen( $s ) > 0 ) {
						$ax2[] = $this->readEmailAddress( $s );
					}
				}
				$params[$key] = $ax2;
			}
		}
		
		foreach ( $params as $key => $val ) {
			$this->params[$key] = $val;
		}
*/
	}

	public function loadEmailLine( $key, $ln ) {
		$this->params[$key] = self::readEmailAddresses($ln);
	}

	public function displayParams( $b_show = true ) {
		$s = "";
		$s .= "<table border='1'>\r\n";
		foreach ( $this->params as $key => $val ) {
			$s .= "<tr>\r\n";
			$s .= "<td valign='top'>{$key}</td>\r\n";
			$s .= "<td>\r\n";
			if ( is_array( $val ) ) {
				$s .= "<table border='1'>\r\n";
				foreach ( $val as $val2 ) {
					$s .= "<tr><td>\r\n";
					if ( is_array( $val2 ) ) {
						$s .= "<table border='1'>";
						foreach ( $val2 as $val3 ) {
							$s .= "<tr><td>{$val3}</td></tr>\r\n";
						}
						$s .= "</table>\r\n";
					} else {
						$s .= $val2;
					}
					$s .= "</td></tr>\r\n";
				}
				$s .= "</table>\r\n";
			} else {
				$s .= str_replace("\r\n","<br>",$val);
			}
			$s .= "</td>\r\n";
			$s .= "</tr>\r\n";
		}
		$s .= "</table>\r\n";
		
		if ( $b_show ) {
			echo $s;
		} else {
			return $s;
		}
	}

	public function getParam( $key ) {
		if ( isset( $this->params[$key] ) ) {
			return $this->params[$key];
		} else {
			return null;
		}
	}

	public function setParam( $key, $val ) {
		if ( is_null( $val ) ) {
			unset( $this->params[$key] );
		} else {
			$this->params[$key] = $val;
		}
	}

	public function addParam( $key, $x ) {
		if ( !isset( $this->params[$key] ) ) {
			$ax = array();
		} else {
			$ax = $this->params[$key];
		}
		$ax[] = $x;
		$this->params[$key] = $ax;
	}

	public function addHeader( $key, $val ) {
		$this->headers[$key] = $val;
	}

	private function lineEncode( $s ) {
		$encode = $this->getEmailEncoding();
		$encode_prefix = "=?" . $encode . "?B?";

		$ret = "";
		$cnt = 0;
		$ch = "";
		$buff = "";
		$line_no = 1;
		$ss = mb_convert_encoding( $s, $encode, $this->getEncoding() );
		$ss_len = mb_strlen( $ss, $encode );

		for( $i = 0; $i < $ss_len; $i++ ) {
			$ch = mb_substr( $ss, $i, 1, $encode );
			$cnt += strlen( $ch );
			$buff .= $ch;

			if ( $cnt > 60 ) {
				if ( $line_no > 1 ) { $ret .= "\r\n "; }
				$ret .= $encode_prefix . base64_encode($buff) . "?=";
				$line_no++;
				$buff = "";
				$cnt = 0;
			}
		}

		if( $buff != "" ) {
			if ( $line_no > 1 ) { $ret .= "\r\n "; }
			$ret .= $encode_prefix . base64_encode( $buff ) . "?=";
		}

		return $ret;
	}

	private function getEncoding() {
		if ( isset($this->params['Encoding']) ) {
			return $this->params['Encoding'];
		} else {
			return "utf-8";
		}
	}
	
	private function getEmailCharSet() {
		return $this->getEmailEncoding();
	}

	private function isAscii( $s ) {
		mb_regex_encoding ( $this->getEncoding() );
		return mb_ereg_match( "^[\x20-\x7E]*$", $s );
	}
	
	private function createAddressLine( $ax ) {

		$s = "";
		foreach ( $ax as $val ) {
			if ( $s != '' ) { $s .= ", "; }

			$addr = $val[0];
			if ( isset( $val[1] ) ) {
				$name = $val[1];
				if ( $this->isAscii($name) ) {
					$s .= $name . " <" . $addr . ">";
				} else {
					$s .= $this->lineEncode( $name ) . " <" . $addr . ">";
				}
			} else {
				$s .= $addr;
			}
		}
		
		return $s;
	}

	private function dataSig() {
		return '//**//';
	}

	private function bodyExists() {
		return ( isset( $this->params['Body'] ) );
	}

	private function htmlExists() {
		return ( isset( $this->params['Html'] ) );
	}

	private function attachmentExists() {
		return isset( $this->params['Attachment'] );
	}

	private function writeBoundaryMixDef() {
		$this->write( "Content-Type: multipart/mixed;\r\n " .
			"boundary=\"{$this->mime_boundary_mix}\"\r\n" );
	}

	private function WriteBoundaryAltDef() {
		$this->write( "Content-Type: multipart/alternative;\r\n " .
			"boundary=\"{$this->mime_boundary_alt}\"\r\n\r\n" );
	}

	private function writeDataHeader() {
		//--- "From", "To", "Reply-To", "Cc", "Bcc"
		$ls = array( "From", "To", "Reply-To", "Cc", "Bcc" );
		foreach ( $ls as $key ) {
			if ( isset( $this->params[$key] ) && !empty( $this->params[$key] ) ) {
				$this->write( $key . ": " . $this->createAddressLine( $this->params[$key] ) . "\r\n" );
			}
		}

		//--- "Subject"
		$this->write( "Subject: " . $this->lineEncode( $this->params['Subject'] ) . "\r\n" );

		//--- Declear MIME Version
		$this->write( "MIME-Version: 1.0\r\n" );

		//--- Additional Headers
		if ( isset( $this->headers ) ) {
			foreach ( $this->headers as $key => $val ) {
				if ( $val != '' ) {
					$this->write( $key . ': ' . $val . "\r\n" );
				}
			}
		}

		//--- Add Mine Boundary Sig. to Header
		$this->writeBoundaryMixDef();

		//--- Add a Blank Line
		$this->write( "\r\n" );
	}

	private function writeMuliPartMsg() {
		$this->write( "This is a multi-part message in MIME format.\r\n\r\n" );

	}

	private function writeBoundaryMix( $b_end = false ) {
		$ending = $b_end ? "--\r\n\r\n" : "\r\n";
		$this->write( "--{$this->mime_boundary_mix}{$ending}" );
	}

	private function writeBoundaryAlt( $b_end = false ) {
		$ending = $b_end ? "--\r\n\r\n" : "\r\n";
		$this->write( "--{$this->mime_boundary_alt}{$ending}" );
	}

	private function writeBody() {
		$s = '';
		$s .= "Content-Type: text/plain;\r\n charset=\"" . $this->getEmailCharSet() . "\"\r\n";
		$s .= "Content-Transfer-Encoding: base64\r\n\r\n";
		$this->write( $s );

		$s = $this->params['Body'];
		$s = mb_convert_encoding( $s, $this->getEmailEncoding(), $this->getEncoding() );
		$s = $this->base64EncodeAndSplit( $s );
		$this->write( $s );
		$this->write( "\r\n" );
	}

	private function writeHtml() {
		$s = '';
		$s .= "Content-Type: text/html;\r\n charset=\"" . $this->getEmailCharSet() . "\"\r\n";
		$s .= "Content-Transfer-Encoding: base64\r\n\r\n";
		$this->write( $s );

		$s = $this->params['Html'];
		$s = mb_convert_encoding( $s, $this->getEmailEncoding(), $this->getEncoding() );
		$s = $this->base64EncodeAndSplit( $s );
		$this->write( $s );
		$this->write( "\r\n" );
	}

	private function writeAttachments( $attachment ) {
		$att_file_path = $attachment[0];
		$att_file_type = $attachment[1];
		$att_file_name = $attachment[2];
		$att_file_name = $this->lineEncode( $att_file_name );

		$s = '';
		$s .= "Content-Type: {$att_file_type};\r\n";
		$s .= " name=\"{$att_file_name}\"\r\n";
		$s .= "Content-Disposition: attachment;\r\n";
		$s .= " filename=\"{$att_file_name}\"\r\n";
		$s .= "Content-Transfer-Encoding: base64\r\n\r\n";
		$this->write( $s );

		if ( substr( $att_file_path, 0, strlen( $this->dataSig() ) ) == $this->dataSig() ) {
			//-- Immediate Data
			$filedata = substr( $att_file_path, strlen( $this->dataSig() ) );

			//--- Use chunk split
			$filedata = chunk_split( base64_encode( $filedata ) );

			if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( false ); }
			$this->write( $filedata );
			if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( true ); }
			$this->write( "\r\n\r\n" );
		} else {
			//-- From file
			if ( false ) {
				//-- Encode entire file
				$file = fopen( $att_file_path, 'rb' ); 
				$filedata = fread( $file, filesize( $att_file_path ) ); 
				fclose( $file );
				$filedata = chunk_split( base64_encode( $filedata ) );

				if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( false ); }
				$this->write( $filedata );
				if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( true ); }

				$this->write( "\r\n" );
			} else {
				//-- Encode a file in chunks
				$file = fopen( $att_file_path, 'rb' );
				stream_filter_append( $file, 'convert.base64-encode' );

				if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( false ); }
				while ( !feof( $file ) ) {
					$filedata = fread( $file, 8192 );
					$filedata = chunk_split( $filedata, 60 );
					$this->write( $filedata );
				}
				if ( !self::LOG_MULTI_PART_DATA ) { $this->enableLog( true ); }

				fclose( $file );

				$this->write( "\r\n" );
			}
		}
	}

	private function writeDataSection() {
		//-- [BEGIN] Set up Boundary
		$t = time();

		$semi_rand = md5( $t ); 
		$this->mime_boundary_mix = "==Multipart_Boundary_x{$semi_rand}x"; 

		$semi_rand = md5( $t-100 ); 
		$this->mime_boundary_alt = "==Multipart_Boundary_x{$semi_rand}x"; 
		//-- [END] Set up Boundary

		$this->writeDataHeader();

		$this->writeMuliPartMsg();

		$this->writeBoundaryMix();

		{
			$this->writeBoundaryAltDef();

			if ( $this->bodyExists() ) {
				$this->writeBoundaryAlt();
				$this->writeBody();
			}

			if ( $this->htmlExists() ) {
				$this->writeBoundaryAlt();
				$this->writeHtml();
			}

			$this->writeBoundaryAlt(true);
		}

		if ( $this->attachmentExists() ) {
			foreach ( $this->params['Attachment'] as $attachment ) {
				$this->writeBoundaryMix();
				$this->writeAttachments( $attachment );
			}
		}

		$this->writeBoundaryMix(true);

		$this->write( "." .  "\r\n");
	}

	//----------------------------------------------------------------
	// smtp interaction
	//----------------------------------------------------------------
	public function getErrMsg() {
		return $this->err_msg;
	}

	public function getSmtpLog() {
		return $this->getVersion() . "\r\n" . $this->log;
	}

	public function displaySmtpLog() {
		echo "<pre>" . str_replace( "\n", "<br>",
			str_replace( "\r", "", $this->getSmtpLog() )) . "</pre>";
	}

	private function read() {
		$b_err =false;
		$errx = array();
		while( true ) {
			$s = fgets($this->handle, 1024);
			if ( $s === false ) { $s = "FALSE"; }

			$this->writeLog( "" . $s );

			if ( $this->isSmtpError( $s ) ) {
				$b_err = true;
				$errx[] = $s;
			}

			if ( !$this->bMore( $s ) ) {
				if ( $b_err ) {
					$this->err_msg = implode( "\r\n", $errx );
					return false;
				} else {
					return true;
				}
			}
		}
	}

	private function enableLog( $b ) {
		$this->b_log = $b;
		$this->writeLog( "###LOGGING = " .
			( $b ? "ON" : "OFF" ) . "\r\n"
		);
	}

	private function write( $s ) {
		if ( $this->b_log ) $this->writeLog( "" . $s );
		fputs( $this->handle, $s );
	}

	private function writeLog( $s ) {
		$this->log .= $s;
	}

	private function isSmtpError( $s ) {
		$ch = substr( $s, 0, 1 );
		return !(( $ch == '2' ) || ( $ch == '3' ));
	}

	private function bMore( $s ) {
		$ch = substr( $s, 3, 1 );
		return ( $ch == '-' );
	}

	private function process() {
		$params = $this->params;

		if ( !$this->read() ) { return false; }

		$auth = '';
		if ( isset( $params['Auth'] ) ) {
			$auth = $params['Auth'];
		}

		$cmd = 'helo';
		switch( $auth ) {
		case '': break;
		default:
			$cmd = 'ehlo';
			$auth = $auth;
			break;
		}

		//-- Helo / Ehlo
		$this->write( "{$cmd} " . $this->hostname . "\r\n" );
		if ( !$this->read() ) { return false; }

		//-- Do authenticate
		if ( !empty( $auth ) ) {
			$username = '';
			if ( isset( $params['Username'] ) ) {
				$username = $params['Username'];
			}

			$password = '';
			if ( isset( $params['Password'] ) ) {
				$password = $params['Password'];
			}

			switch( $auth ) {
			case 'LOGIN':
				$this->write( "auth login\r\n" );
				if ( !$this->read() ) { return false; }

				$this->EnableLog( false );
				$this->write( base64_encode($username) . "\r\n" );
				$this->EnableLog( true );

				if ( !$this->read() ) { return false; }

				$this->EnableLog( false );
				$this->write( base64_encode($password) . "\r\n" );
				$this->EnableLog( true );

				if ( !$this->read() ) { return false; }
				break;
			}
		}

		//-- mail from
		$from = $params['From'];
		$from0 = $from[0];
		$from_addr = $from0[0];

		$this->write( "mail from: " . $from_addr . "\r\n" );
		if ( !$this->read() ) { return false; }

		//--- [BEGIN] rcpt to
		// You need to do this for every to, cc, and bcc.

		$ls = array( "To", "Cc" , "Bcc" );
		foreach ( $ls as $key ) {
			if ( isset( $params[$key] ) && !empty( $params[$key] ) ) {
				$ax = $params[$key];
				foreach ( $ax as $to_email ) {
					$addr = $to_email[0];
					$this->write( "rcpt to: " . $addr . "\r\n" );
					if ( !$this->read() ) { return false; }
				}
			}
		}
		//--- [END] rcpt to

		$this->write( "data" . "\r\n" );
		if ( !$this->read() ) { return false; }

		$this->writeDataSection();
		if ( !$this->read() ) { return false; }

		//--- quit
		$this->write( "quit" . "\r\n" );
		if ( !$this->read() ) { return false; }

		return true;
	}

	private function run() {
		$this->log = '';
		$this->err_msg = '';
		$this->b_log = true;
		$params = $this->params;

		if ( isset( $params['Hostname'] ) ) {
			$this->hostname = $params['Hostname'];
		} else {
			$this->hostname = ini_get("SMTP");
		}

		if ( isset( $params['Port'] ) ) {
			$this->port = $params['Port'];
		} else {
			$this->port = ini_get("smtp_port");
		}

		if ( isset( $params['Transport'] ) ) {
			$this->transport = $params['Transport'] . '://';
		} else {
			$this->transport = '';
		}

		//--- open connection
		$this->handle = @fsockopen( $this->transport . $this->hostname,
			$this->port, $errno, $errstr, self::SMTP_TIMEOUT );

		if ( $this->handle === false ) {
			if ( $errstr == null ) { $errstr = ''; }
			if (( $errno == 0 ) || ( $errstr == '' )) {
				$this->err_msg = "Could not connect to mail server [" . $this->hostname . "]";
			} else {
				$this->err_msg = $errstr . "({$errno})";
			}

			return false;
		}

		//--- process
		$success = $this->process();

		//--- close  connection
		fclose( $this->handle );

		return $success;
	}

	public function send() {
		$this->addHeader( 'Date', date( "D, d M Y H:i:s O" ) );
		return $this->run(); 
	}
}

?>