<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CEnv {

	private static $cfg_params_queue = array();
	private static $cfg_params = array();

	public static function cfg( $key ) {
		if ( isset( self::$cfg_params[ $key ] ) ) {
			return self::$cfg_params[ $key ];
		} else {
			return '';
		}
	}

	public static function getLibPath() {
		return self::$cfg_params['path-lib'];
	}

	public static function getConfigPath() {
		return self::$cfg_params['path-config'];
	}

	public static function getLangPath() {
		$path = self::$cfg_params['path-locale'];
		if ( !empty( self::$cfg_params['lang-code'] ) ) {
			$path .= self::$cfg_params['lang-code'] . '/';
		}
		return $path;
	}

	public static function loadConfig( $name, &$_cfg ) {
		include( self::getConfigPath() .
			"config.{$name}.inc.php" );
	}

	public static function loadLang( $name, &$_lng ) {
		include( self::getLangPath() .
			"locale.{$name}.inc.php" );
	}

	public static function &getCfgParams() {
		return self::$cfg_params;
	}

	public static function getEntryIndex() {
		return count( self::$cfg_params_queue );
	}

	public static function getEntryPath() {
		return self::$cfg_params['path-entry'];
	}

	public static function getEntryUrl() {
		return self::$cfg_params['url-entry'];
	}

	public static function getCurrentPageUrl( $http = true ) {
		$url = "";

		if ( $http ) {
			$url .= "http";

			$b_https = (( isset( $_SERVER["HTTPS"] ) ) && ( $_SERVER["HTTPS"] == "on" ));
			if ( $b_https ) {
				$url .= "s";
			}

			$url .= "://" . $_SERVER["SERVER_NAME"];

			if (( $_SERVER["SERVER_PORT"] != "80" ) && !$b_https ) {
				$url .= ":" . $_SERVER["SERVER_PORT"];
			}
		}

		//-- $_SERVER["SCRIPT_NAME"] trancates GET params and PathInfo.
		$url .= $_SERVER["SCRIPT_NAME"];

		return $url;
	}

	public static function useLib( $lib ) {
		include_once( self::getLibPath() . $lib . '/index.inc.php' );
	}

	private static function push() {
		array_push( self::$cfg_params_queue, self::$cfg_params );
		self::$cfg_params = array();
	}

	private static function pop() {
		self::$cfg_params = array_pop( self::$cfg_params_queue );
	}

	private static function setup( $path_entry ) {

		//-- set up entry parameters
		self::$cfg_params['entry-index'] = self::getEntryIndex();
		self::$cfg_params['path-entry'] = $path_entry;
		self::$cfg_params['url-entry'] = dirname( self::getCurrentPageUrl() ) . '/';

		//-- load configurations
		$_cfg =& self::$cfg_params;
		require( dirname(dirname(dirname(dirname(__FILE__)))) .
			'/config/config.env.inc.php' );

		//-- merge env params external
		global $env_params_external;
		if ( isset( $env_params_external ) ) {
			$_cfg = array_merge( $_cfg, $env_params_external );
			unset( $env_params_external );
		}

		//-- date-timezone
		if ( !empty( $cfg_params[ 'date-timezone' ] ) ) {
			$date_timezone = $cfg_params[ 'date-timezone' ];
		} else {
			$date_timezone = ini_get( 'date.timezone' );
			$date_timezone = str_replace( " ", "_", $date_timezone );
		}
		if ( !empty( $date_timezone ) ) {
			date_default_timezone_set( $date_timezone );
		}

		//-- reverse magic_quote effect
		if ( function_exists("get_magic_quotes_gpc") && get_magic_quotes_gpc() ) {

			function stripslashes_deep( $value ) {
				$value = is_array( $value ) ?
					array_map( 'stripslashes_deep', $value ) :
					stripslashes( $value );
				return $value;
			}

			$_POST = array_map( 'stripslashes_deep', $_POST );
			$_GET = array_map( 'stripslashes_deep', $_GET );
			$_COOKIE = array_map( 'stripslashes_deep', $_COOKIE );
			$_REQUEST = array_map( 'stripslashes_deep', $_REQUEST );
		}

		//-- session name & interval

	}

	private static function run() {
		global $sys;
		if ( isset( $sys ) ) {
			$sys_curr = $sys;
		}

		$sys = new CSys();
		$sys->run();

		if ( isset( $sys_curr ) ) {
			$sys = $sys_curr;
		}
	}

	public static function main( $path_entry ) {
		self::push();
		self::setup( $path_entry );
		self::run();
		self::pop();
	}
}

?>