<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CHtmlTag {

	public $tag_name;
	public $attr;
	public $inside;

	public function __construct( $tag_name ) {
		$this->tag_name = $tag_name;
		$this->attr = array();
		$this->inside = null;
	}

	public static function create( $tag_name ) {
		return new CHtmlTag( $tag_name );
	}

	function setTagName( $tag_name ) {
		$this->tag_name = $tag_name;
		return $this;
	}

	function setInside( $inside ) {
		$this->inside = $inside;
		return $this;
	}

	//-------------------------------------------
	// set
	//-------------------------------------------
	//
	// Add 'readonly'
	// ->set( 'readonly' )
	//
	// Remove 'readonly'
	// ->remove( 'readonly' )
	//
	// Add 'checked'
	// ->set( 'checked' )
	//
	// remove 'checked'
	// ->remove( 'checked' )
	//
	// Add 'name'
	// ->set( 'name', 'street' )
	//
	// Remove 'name'
	// ->remove( 'name' )
	//
	// Append new class to exisiting class
	// ->add( 'class', 'myclass' )
	//
	// Replace exisiting class with a new class
	// ->set( 'class', 'myclass' )
	//
	// Remove exisiting class
	// ->remove( 'class', "myclass" );
	//
	// Append new style to exisiting style
	// ->set( 'style', array( 'color'=>'#ffffff', 'font-size'=>12 ) )
	//
	// Replace exisiting style with new style
	// ->set( 'style', array( 'color'=>'#ffffff', 'font-size'=>12 ), false )
	//
	// Remove exisiting style
	// ->remove( 'style' )
	//
	//-------------------------------------------
	function set( $key, $val = null ) {
		if (( $key == 'class' ) || ( $key == 'style' )) {
			if ( isset( $this->attr[ $key ] ) ) {
				$this->attr[ $key ] = array_merge(
					$this->attr[ $key ], $val );
			} else {
				$this->attr[ $key ] = $val;
			}
		} else {
			if ( is_null( $val ) ) {
				$this->attr[] = $key;
			} else {
				$this->attr[$key] = $val;
			}
		}
		return $this;
	}

	function remove( $key1, $key2 = null ) {
		if ( is_null( $key2 ) ) {
			unset( $this->attr[ $key1 ] );
		} else {
			unset( $this->attr[ $key1 ][ $key2 ] );
		}
		return $this;
	}

	function render() {
		$ax = array();
		$ax[] = '<' . $this->tag_name;
		foreach( $this->attr as $key => $val ) {
			if ( is_int( $key ) ) {
				$ax[] = $val;
			} else if ( $key == 'class' ) {
				$class= implode( ' ', $val );
				$ax[] = $key . "=\"" . $class . "\"";
			} else if ( $key == 'style' ) {
				$style= '';
				foreach( $val as $k => $v ) {
					$style .= $k . ':' . $v . ';';
				}
				$ax[] = $key . "=\"" . $style . "\"";
			} else {
				$ax[] = $key . "=\"" . htmlspecialchars( $val ) . "\"";
			}
		}
		$s = implode( ' ', $ax );

		if ( is_object( $this->inside ) ) {
			$inside = $this->inside->render();
		} else {
			$inside = $this->inside;
		}

		if ( is_null( $inside ) ) {
			$s .= ' />';
		} else {
			$s .= '>' . $inside . '</' . $this->tag_name . '>';
		}

		return $s;
	}
}

?>