<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CJsReso {

	private static $lng = array();
	private static $cfg = array();

	private static function str( $s ) {
		$s = str_replace( "\\", "\\\\", $s );
		$s = str_replace( "\t", "\\t", $s );
		$s = str_replace( "\r", "\\r", $s );
		$s = str_replace( "\n", "\\n", $s );
		$s = str_replace( '"', "\\\"", $s );
		return '"' . $s . '"';
	}

	private static function render( $val ) {
		if ( is_array( $val ) ) {
			$v = json_encode($val);
		} else if ( is_numeric( $val ) ) {
			$v = $val;
		} else {
			$v = self::str($val);
		}
		return $v;
	}

	public static function loadLang( $name, $ls = null ) {
		CEnv::loadLang( $name, $_lng );
		if ( $ls == null ) {
			$ls = array_keys( $_lng );
		}

		self::$lng[] = "tScope_lngs['{$name}'] = lng = {};";
		foreach( $ls as $key ) {
			self::$lng[] = "lng['{$key}'] = " .
				self::render($_lng[$key])  . ";";
		}
	}

	public static function loadConfig( $name, $ls = null ) {
		CEnv::loadConfig( $name, $_cfg );
		if ( $ls == null ) {
			$ls = array_keys( $_cfg );
		}

		self::$cfg[] = "tScope_cfgs['{$name}'] = cfg = {};";
		foreach( $ls as $key ) {
			self::$cfg[] = "cfg['{$key}'] = " .
				self::render($_cfg[$key])  . ";";
		}
	}

	public static function output() {
		$rx = array();
		$rx[] = "<script>";
		$rx[] = "var cfg;";
		$rx[] = "tScope_cfgs = {};";
		$rx = array_merge($rx,self::$cfg);
		$rx[] = "var lng;";
		$rx[] = "tScope_lngs = {};";
		$rx = array_merge($rx,self::$lng);
		$rx[] = "</script>";
		$rx[] = "\r\n";
		echo implode( "\r\n", $rx );
	}

}

?>