<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CPageSig {

	const STR_SYSPAGESIG_KEY = '_page_sig';
	const STR_SEPA = '[x-|-x]';

	private static $lng_params = array();

	public static function lng( $key ) {
		CEnv::loadLang( "pagesig", self::$lng_params );
		return self::$lng_params[ $key ];
	}

	public static function mark( $psig_key = null ) {
		if ( is_null( $psig_key ) ) {
			$psig_key = __FILE__;
		}

		$page_sig_val = self::createRandomString( 32 );

		CSession::setup();
		$_SESSION[$page_sig_val] = $page_sig_val;

		CState::setup();
		CState::set( self::STR_SYSPAGESIG_KEY, 
			$psig_key . self::STR_SEPA . $page_sig_val );
	}

	public static function clear( $psig_key = null ) {
		if ( is_null( $psig_key ) ) {
			$psig_key = __FILE__;
		}
		return self::check( $psig_key, true );
	}

	public static function check( $psig_key = null, $b_clear = false ) {
		if ( is_null( $psig_key ) ) {
			$psig_key = __FILE__;
		}

		$key = CState::get( self::STR_SYSPAGESIG_KEY );
		if ( is_null( $key ) ) return false;

		$ax = explode( self::STR_SEPA, $key );
		if ( count( $ax ) != 2 ) return false;

		$page_sig_key = $ax[0];
		$page_sig_val = $ax[1];

		if ( $page_sig_key != $psig_key ) return false;

		CSession::setup();
		if ( !isset( $_SESSION[$page_sig_val] ) ) return false;
		if ( $_SESSION[$page_sig_val] != $page_sig_val ) return false;
		if ( $b_clear ) unset( $_SESSION[$page_sig_val] );

		return true;
	}

	private static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			$s .= chr(rand(97, 122));
		}
		return $s;
	}
}

?>