<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CRoles {

	private static $my_roles = array();
	private static $role_specs = null;

	public static function loadCfg() {
		if ( !self::$role_specs ) {
			CEnv::loadConfig( "roles", $cfg );
			self::$role_specs =& $cfg["role-specs"];
		}
	}

	public static function add( $role ) {
		if ( !in_array($role,self::$my_roles) ) {
			array_unshift( self::$my_roles, $role );
		}
	}

	public static function remove( $role ) {
		if ( $role == '*' ) {
			self::$my_roles = array();
		} else {
			if ( ($key = array_search($role, self::$my_roles)) !== false ) {
				unset(self::$my_roles[$key]);
			}
		}
	}

	public static function hasPms( $reso ) {
		self::loadCfg();
		foreach( self::$my_roles as $role ) {
			if ( isset(self::$role_specs[$role]) ) {
				$spec = self::$role_specs[$role];
				if ( isset($spec[$reso]) ) {
					$permission = $spec[$reso];
					return ( $permission == 1 );
				}
			}
		}
		return false;
	}

	public static function hasRole( $role ) {
		return ( array_search($role, self::$my_roles) !== false );
	}

	public static function requireRole( $role ) {
		if ( !self::hasRole( $role ) ) {
			header("HTTP/1.1 401 Unauthorized");
			exit( "Unauthorized Access" );
		}
	}

	public static function printRoles() {
		return implode( ", ", self::$my_roles );
	}

	public static function printPms() {
		self::loadCfg();
		$rx = array();
		foreach( self::$my_roles as $role ) {
			if ( isset(self::$role_specs[$role]) ) {
				$spec = self::$role_specs[$role];
				foreach( $spec as $reso=>$pms ) {
					$rx[] = "$reso:$pms";
				}
			}
		}
		return implode( ", ", $rx );
	}
}

?>