<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

abstract class CTable {

	public function __construct( $name ) {
		$this->name = $name;
		$this->dname = null;
		$this->fdx = array();
		$this->setup();
	}

	abstract protected function setup();

	public function fieldset() {
		return new CFieldSet( $this );
	}

	public function getTablename() {
		if ( $this->dname == null ) {
			return CDBConf::getTablePrefix() . $this->name;
		} else {
			return $this->dname;
		}
	}

	public function &makeList( $selector ) {
		$rx = array();
		foreach( $this->fdx as $fname => &$fd ) {
			if ( in_array( $selector, $fd['list-key'] ) ) {
				$rx[] = $fname;
			}
		}
		return $rx;
	}

	public function getPrimaryKey() {
		foreach( $this->fdx as $fname => &$fd ) {
			if ( in_array( "pkey", $fd['list-key'] ) ) {
				return $fname;
			}
		}
		return null;
	}

	public function findRec( $expr, $cond ) {
		$rs = null;
		$sqs = array();
		$sqs['verb'] = 'select';
		$sqs['table'] = $this->getTablename();
		$sqs['expr'] =& $expr;
		$sqs['where']['op'] = 'AND';
		$sqs['where']['cond'] =& $cond;
		$sqs['limit'] = 1;
		if ( $result = CSqo::query( $sqs ) ) {
			$rs = CSqo::getRowA( $result );
		}
		return $rs;
	}

	public function updateRec( $data, $cond ) {
		$sqs = array();
		$sqs['verb'] = 'update';
		$sqs['table'] = $this->getTablename();
		$sqs['data'] =& $data;
		$sqs['where']['op'] = 'AND';
		$sqs['where']['cond'] =& $cond;
		CSqo::query( $sqs );
	}

	public function insertRec( $data ) {
		$sqs = array();
		$sqs['verb'] = 'insert';
		$sqs['table'] = $this->getTablename();
		$sqs['data'] =& $data;
		CSqo::query( $sqs );
		return CSqo::getInsertID();
	}

	public function deleteRec( $cond ) {
		$sqs = array();
		$sqs['verb'] = 'delete';
		$sqs['table'] = $this->getTablename();
		$sqs['where']['op'] = 'AND';
		$sqs['where']['cond'] =& $cond;
		CSqo::query( $sqs );
	}

	public function purgeRec( $keep ) {
		if ( $keep >= 0 ) {
			$id = null;
			$pkey = $this->getPrimaryKey();

			$sqs = array();
			$sqs['verb'] = 'select';
			$sqs['table'] = $this->getTablename();
			$sqs['expr'][] = $pkey;
			$sqs['orderby'] = array($pkey=>"DESC");
			$sqs['offset'] = $keep;
			$sqs['limit'] = 1;
			if ( $result = CSqo::query( $sqs ) ) {
				if ( $rs = CSqo::getRowA( $result ) ) {
					$id = $rs[$pkey];
				}
				CSqo::freeResult($result);
			}

			if ( is_null($id) ) { return; }

			$sqs = array();
			$sqs['verb'] = 'delete';
			$sqs['table'] = $this->getTablename();
			$sqs['where'] = array($pkey, "<=", $id);
			CSqo::query( $sqs );
		}
	}
}

?>