<?php
//==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>==>>>
//
// Fade-In Slideshow v2.14 [ FREE TRIAL VERSION ]
// Copyright (c) phpkobo.com ( http://www.phpkobo.com/ )
// Email : admin@phpkobo.com
// ID : FISLS-214
//
//==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<==<<<

class CUSess {

	private static function startSession() {
		CSession::setup();
	}

	private static function getSesKey() {
		return 'SESKEY-' . dirname(__FILE__) . '-';
	}

	private static function getTokenCookieKey() {
		return 'usess-token';
	}

	private static function createRandomString( $n ) {
		$s = '';
		for ( $i = 0; $i < $n; $i++ ) {
			$s .= chr(rand(97, 122));
		}
		return $s;
	}

	private static function getUserID( $tablename, $idname ) {
		$user_id = null;
		$ckey = self::getTokenCookieKey();

		if ( isset( $_COOKIE[$ckey] ) ) {
			$token = $_COOKIE[$ckey];
			$ax = explode( "-", $token );
			$t = intval( $ax[0] );

			if ( $t > time() ) {
				$sqs = array();
				$sqs['verb'] = 'select';
				$sqs['table'] = $tablename;
				$sqs['expr'][] = $idname;

				$wh =& $sqs['where'];
					$wh['op'] = 'AND';
					$cond =& $wh['cond'];
						$cond[] = array( "usess_token", '=', $token );
				$sqs['limit'] = '1';
				$result = CSqo::query( $sqs );
				if ( $rs = CSqo::getRowA( $result ) ) {
					$user_id = $rs[$idname];
				}
				CSqo::freeResult( $result );
			}
		}

		return $user_id;
	}

	private static function updateRoles() {
		CRoles::remove( '*' );
		if ( self::isLoggedIn() ) {
			CRoles::add('user');
			if ( self::get('b_super') == 1 ) {
				CRoles::add('sa');
			}
		}
	}

	private static function loadUserData( $tablename, $idname, $user_id ) {
		$seskey = self::getSesKey();

		$sqs = array();
		$sqs['verb'] = 'select';
		$sqs['table'] = $tablename;

		$wh =& $sqs['where'];
			$wh['op'] = 'AND';
			$cond =& $wh['cond'];
				$cond[] = array( $idname, '=', $user_id );
		$sqs['limit'] = '1';
		$result = CSqo::query( $sqs );
		if ( $rs = CSqo::getRowA( $result ) ) {
			foreach( $rs as $key => $val ) {
				$_SESSION[$seskey . $key] = $val;
			}
			$tx = explode( "-", $rs['usess_token'] );
			$_SESSION[$seskey . '?'] = intval($tx[0]);
		}
		CSqo::freeResult( $result );
	}

	public static function setup( $tablename, $idname ) {
		self::startSession();
		$seskey = self::getSesKey();

		$k = $seskey . '?';
		if ( !isset($_SESSION[$k]) ) {
			$user_id = self::getUserID( $tablename, $idname );
			if ( !is_null($user_id) ) {
				self::loadUserData( $tablename, $idname, $user_id );
			}
		}

		//-- update roles
		self::updateRoles();
	}

	public static function start( $tablename, $idname, $user_id ) {
		self::terminate();
		$seskey = self::getSesKey();

		CEnv::loadConfig( "usess", $cfg );
		$end_time = time() + $cfg["timeout"];

		//-- create token
		$token = $end_time . '-' . self::createRandomString(64);

		//-- set token to database
		$sqs = array();
		$sqs['verb'] = 'update';
		$sqs['table'] = $tablename;
		$dx =& $sqs['data'];
			$dx[ 'usess_token' ] = $token;
		$wh =& $sqs['where'];
			$wh['op'] = 'AND';
			$cond =& $wh['cond'];
				$cond[] = array( $idname,
					"=", $user_id );
		CSqo::query( $sqs );

		//-- set token to cookie
		global $sys;
		setcookie(self::getTokenCookieKey(), $token, 0, $sys->getAppUrl() );

		//-- get user data
		self::loadUserData( $tablename, $idname, $user_id );

		//-- update roles
		self::updateRoles();
	}

	public static function terminate() {
		self::startSession();
		$seskey = self::getSesKey();

		//-- delete data in $_SESSION
		$kx = array();
		foreach( $_SESSION as $key => $val ) {
			if ( substr($key,0,strlen($seskey)) == $seskey ) {
				$kx[] = $key;
			}
		}

		foreach( $kx as $key ) {
			unset($_SESSION[$key]);
		}

		//-- delete cookie
		global $sys;
		setcookie(self::getTokenCookieKey(), '', -1, $sys->getAppUrl() );

		//-- update roles
		self::updateRoles();
	}

	private static function isLoggedIn() {
		$end_time = self::get( '?' );
		return ( $end_time != null ) &&
			( $end_time > time() );
	}

	public static function get( $key ) {
		$k = self::getSesKey() . $key;
		if ( isset($_SESSION[$k]) ) {
			return $_SESSION[$k];
		} else {
			return null;
		}
	}

	public static function getTimeoutStr() {
		$t = self::get('?');

		$now = time();
		$d = ( $t - $now );

		if ( $d < 60 ) {
			$s = sprintf( "%d second", $d ) .
				( $d == 1 ? '' : 's' );
		} else {
			$d = intval( $d / 60 );
			if ( $d < 60 ) {
				$s = sprintf( "%d minute", $d ) .
					( $d == 1 ? '' : 's' );
			} else {
				$d = intval( $d / 60 );
				if ( $d < 24 ) {
					$s = sprintf( "%d hour", $d ) .
						( $d == 1 ? '' : 's' );
				} else {
					$d = intval( $d / 24 );
					if ( $d < 7 ) {
						$s = sprintf( "%d day", $d ) .
							( $d == 1 ? '' : 's' );
					} else {
						$s = date( "Y-m-d", $t );
					}
				}
			}
		}

		return $s;
	}
}

?>